%init values for the agent (and possibly the environment)
function [IP]=INIT(varargin) % INIT = init parameters

IP.chapterName  = varargin{1,1}{1};
IP.articleName  = varargin{1,1}{2};
vararginSize = max(size(varargin{1,1}));
if vararginSize >= 3
IP.params       = varargin{1,1}{3}{1,1};
end

if vararginSize >= 4
    IP.growthChangeTypes = varargin{1,1}{4};
else
    IP.growthChangeTypes = {'abDec'};
end

if vararginSize >= 5
    IP.calcAnSolution = varargin{1,1}{5};
else
    IP.calcAnSolution = false;
end
if vararginSize >= 6
    IP.steps = varargin{1,1}{6};
else
    IP.steps = 300;
end

if vararginSize >= 7
    IP.policy = varargin{1,1}{7};
else
    IP.policy = 'softmax'; % or softmax or gradient_ascent
end

if vararginSize >= 8
    IP.seed = varargin{1,1}{8};
else
    IP.seed = 666; % or softmax or gradient_ascent
end
if vararginSize >= 9
    IP.numInputs = varargin{1,1}{9};
else
    IP.numInputs = 2; % or softmax or gradient_ascent
end

if vararginSize >= 10
    IP.numSeedTries = varargin{1,1}{10};
    
else
    IP.numSeedTries = 1; % or softmax or gradient_ascent
end
if vararginSize >= 3
    IP.SES = varargin{1,1}{3};
end

if vararginSize >= 11
    IP.runsPerSA = varargin{1,1}{11};
    
else
    IP.runsPerSA = 1; 
end

if vararginSize >= 12
    IP.ecoFcn = varargin{1,1}{12};
    
else
    IP.ecoFcn = 'logistic'; 
end

if vararginSize >= 13
    IP.learningType = varargin{1,1}{13};
    
else
    IP.learningType = 'unsupervised'; 
end

if vararginSize >= 14
    IP.plotMMforPaper = varargin{1,1}{14};
    
else
    IP.plotMMforPaper = 0; 
end

if vararginSize >= 15
    IP.anaResult = varargin{1,1}{15};
    
else
    IP.anaResult = 0; 
end

if vararginSize >= 16
    IP.findOptimalParams = varargin{1,1}{16};
    
else
    IP.findOptimalParams = 0; 
end

if vararginSize >= 17
    IP.trainWcutTrace = varargin{1,1}{17};
else
    IP.trainWcutTrace = true; 
end


if vararginSize >= 18
    IP.cutTrace = varargin{1,1}{18};
else
    IP.cutTrace = true; 
end


if vararginSize >= 19
    IP.useSprimByAgent = varargin{1,1}{19};
else
    IP.useSprimByAgent = true; 
end

if vararginSize >= 20
    IP.runsPerDropSeries = varargin{1,1}{20};
else
    IP.runsPerDropSeries = 1; 
end

if vararginSize >= 21
    IP.startStates = varargin{1,1}{21};
else
    IP.startStates = 0.5; 
end

if vararginSize >= 22 && ~isempty(varargin{1,1}{22})
    IP.startActions = varargin{1,1}{22};
else
    IP.startActions = []; 
end


% params for repeating scenarios of change in growth rate
IP.abChangeInterval = 25;
IP.repeatIntervalabRand = 300;
IP.repeatIntervalabIncDec = 50; %was 150
IP.repeatIntervalabIncDecR = 67*3;
IP.repeatIntervalCos = 50;
IP.repeatIntervalSlowCos = 150;


%preTrain

[stat, mess]    = fileattrib;
IP.path         = strcat(fullfile(mess.Name, IP.chapterName), filesep);

% simulation properties


IP.numAgents    = 1;            % the number of agents to use in the simulation
IP.numContacts  = 0;            % the number od contacts the agents has
IP.x            = 1:1:IP.steps; % for plotting figures
IP.MP           = 1;            % 1=tillv?xthastigheten r, manipulated parameter in the ecosystem p! or p2
IP.useSameSeed  = true;         % when using multiple agents they might use different seeds
IP.seedNr       = 1;            % is set by each casestudies m-file (if needed)

IP.agentType    = 'matlab'; % 'matlab' or 'java' % matlab does what java does but only uses the NN function in java, mainly to test if the java agent is correct and it is ...
IP.testStates = linspace(0,1,151); % for checking the menal models optimal path


% growthrate change variables
IP.linearGrowthInc = linspace(0.5,1.5,IP.steps);
IP.linearGrowthDec = linspace(1.5,0.5,IP.steps); % 1.6 in simulateParallelRemote



% RL crisis
IP.dr           = 0.9;%0.88;      % 0.9 discount rate (RL)
IP.ss           = 0.36;%0.28;      % step size (RL)
IP.lrw          = 1.0;      % learning rate weights with trace matlab 0.01 NoTrace: eg 0.001
IP.SMtemp       = 0.001;      % 0.0001 0.003 temperature (RL) softmax choice



IP.learningmodel = 'RLET';

% NN

IP.lrw_g.r      = [0 7];    % range
IP.useGen       = false;     % generalize the output of the total RBF network for each training

% SM: softmax policy

IP.SMtemp_g.r   = [0 1];    % range

% WAP: weighted average position policy
IP.WAPtemp      = 4.0;      % multiplies the spread-value


IP.rbfs         = 64;      % number of RBFs ^3 64,125,216, 343
IP.rbfs_g.r     = [10 60];  % range
IP.RBFsSpread   = 10;


% multi agent simulations
IP.cti          = 25;       % How often the agent wants to be contacted
IP.actions      = 1;        % h?mtas ifr?n ECO-systemet
IP.NNpars       = [IP.actions IP.rbfs IP.seed];

% IP.DefaultAxesColorOrder = [1 0 0;  0 1 0;  0 0 1;  1 1 0; 0 1 1; ...
%     0.9 0 0;0 0.9 0;0 0 0.9;0.9 0.9 0; 0 0.9 0.9];
% IP.DefaultAxesLineStyleOrder = '-|-|-|-|-|--|--|--|--|--';
% IP.XL   = {'a'};
% IP.YL   = {'s'};
% IP.ZL   = {'rs'};

IP.lowerState               = round(IP.steps/3);
IP.doubleState              = round(2*IP.steps/3);

% for using traces, since they repeat trainings less than using no traces
IP.useEligabilityTraces = false;
%IP.rbfsSpreadDivisor = 1;
% if IP.useEligabilityTraces == true
%     IP.lambda                 = [0 0.05 0.1 0.15 0.2 0.25 0.3 0.35 0.4 0.45 0.5 0.55 0.6 0.65 0.7 0.75 0.8]; %linspace(0,1,5) gives 5 steps between 0 and 1
%     IP.glsliderLR               = [0.1 0.1 0.015 0.015 0.015 0.001 0.001 0.0015 0.0005 0.00025 0.000015 0.0000075 0.0000015 0.00000075 0.00000015 0.000000015 0.0000000015]./10; %linspace(0,1,5) gives 5 steps between 0 and 1
% else
%     IP.lambda                =[0   0   0]; %linspace(0,1,5) gives 5 steps between 0 and 1
%     IP.glsliderLR              =[0.5 0.1 0.01]; %linspace(0,1,5) gives 5 steps between 0 and 1
% end

IP.noice = 0; % 0.1 = 10 percent noice (rand(-0.5) * IP.noice)

if strcmp(IP.chapterName, 'Data')
    IP.dr           =IP.params(1,1);
    IP.ss           =IP.params(1,2);

    IP.lr           = IP.params(1,3);
    IP.rbfs         = IP.params(1,4);      % number of RBFs ^3 64,125,216, 343
    IP.rbfsSpreadDivisor = IP.params(1,5);
    IP.SMtemp       = IP.params(1,6);
    IP.lambda       = IP.params(1,7);
    
    IP.gaer         = IP.params(1,8);
    IP.useRL        = IP.params(1,11);  
    IP.useEligabilityTraces  = IP.params(1,12);  
    IP.RBFsSpread  = IP.params(1,13);  

    IP.glsliderLR   = [IP.lr ]; %linspace(0,1,5) gives 5 steps between 0 and 1
    IP.numAgents    = length(IP.lambda);
    IP.manipulatedParams(1) = 0;
    IP.manipulatedDesc(1)   = {'Analythical'};
    for i=1:IP.numAgents
        IP.manipulatedParams(i) = IP.glsliderLR(i);
        IP.manipulatedDesc(i)   = {strcat('LR=', num2str(IP.glsliderLR(i)))};
    end
    IP.plotSteps        = 0; %IP.steps/2;
    IP.x                = IP.plotSteps + 1:1:IP.steps;
end
end
