% fix for repeating growth rate change scenarios
close all

rows=2;
cols=4;

repInterval = 0;
steps = 200;
one_row_fig = 0
%grcs = {'constant' 'linearInc' 'abIncR' 'slowcos'  'cos'   'abRand'   'abDecR'  'linearDec'};
%GrcsPaperNames = { 'Constant' 'Linear Inc.' 'Abrupt Inc.'  'Slow cyclic'  'Fast cyclic' 'Abrupt Rand'   'Abrupt Dec.'  'Linear Dec.'};
grcs = {'constant' 'linearInc' 'abIncR' 'cos'   'abRand'   'abDecR'  'linearDec'};
GrcsPaperNames = { 'Constant' 'Linear Incr' 'Abrupt Incr'  'Cyclic' 'Abrupt Rand'   'Abrupt Decr'  'Linear Decr'};

preTrain = 50;
colors={'k','r', 'g', 'b'};
grcnum = 1;
PP=PLOTPARAMS([]);
h = figure('Visible','on', 'Name', 'Scenarios');
set (gca, 'YTickMode', 'manual')
set(gca,'ticklength',2*get(gca,'ticklength'))


set(gca,'tickdir','out')
for iGrc = 1: length(grcs)
    ECO             = E( 'logistic', 2, 0.55) ;
    growthRateChangeType = grcs{iGrc}
    iRepeat = 0;
    growthRateStartup = ECO.P(1);
    for i = 1:steps
        iRepeat = iRepeat + 1;
        ECO.P(1) = growthRateChange(1, ECO, iRepeat, growthRateChangeType, steps, preTrain);
        grchange(i)=ECO.P(1);
    end
    subplot(rows,cols,grcnum)
    plot(grchange, 'Color', PP.col_(2,:), 'Linewidth', 1.5 )
    yupperlimit= 2;
    ylim([0 yupperlimit])
    hold on
    set(gca,'FontSize', 14)
    title(strcat(GrcsPaperNames(grcnum)), 'FontWeight', 'normal',...
        'FontSize', 18);
     set (gca, 'YTickMode', 'manual')
     set (gca, 'YTickMode', 'manual')
     set(gca,'ticklength',3*get(gca,'ticklength'))


%set(gca,'tickdir','out')
    set(gca,'XTick',[0 50 100 150 steps],'XTickLabel',{'';'';'';'';''},   'LineWidth', 1)%[0 nrows])
    set(gca,'YTick',[0 0.5 1 1.5 yupperlimit],'YTickLabel',{'';'';'';'';''})%[0 nrows])
   
    if grcnum == 1
        %text(1.23, 2.9, 'Scenarios of Change in Growth Rate', 'FontSize', PP.fontSizeNormal, 'FontWeight', 'b');
    end
    if one_row_fig
        plot_axis_at = 1;
    else
        plot_axis_at = 5;
    end
    if grcnum == plot_axis_at
        %text(1.23, 2.9, 'Scenarios of Environmental Change', 'FontSize', PP.fontSizeNormal, 'FontWeight', 'b');
        xlabel('Time')
        ylabel('Growth')
         set(gca,'XTick',[0 50 100 150 steps],...
             'XTickLabel',{'0';'';'100';'';'200'}, ...
             'FontSize', 16, 'LineWidth', 1)%[0 nrows])
    set(gca,'YTick',[0 0.5 1 1.5 yupperlimit],...
        'YTickLabel',{'0';'';'1';'';'2'}, ...
         'FontSize', 16, 'LineWidth', 1)%[0 nrows]))%[0 nrows])
   
        %set(gca,'XTick',[0 steps],'XTickLabel',{'0';'200'}, 'FontSize', 12, 'LineWidth', 1)%[0 nrows])
   % set(gca,'YTick',[0 yupperlimit],'YTickLabel',{'0';'2'})%[0 nrows])
  
    end
    
    grcnum=grcnum+1;
 

end
   saveas(h, 'figures/Fig2_scenariosOfEnvChange.eps','psc2');
