function []=CreatePickupAndOCMethodsFiguresENVCH()
%test for optimal control
% S.P(1)=1; % growth rate (f?r?ndras)
%      S.P(2)=10; %carrying cap
%     S.P(3)=0.01; %immigtation rate

close all
clear all
set(0,'DefaultFigureWindowStyle','docked')
ecoFcns={'logistic'  };


PP = PLOTPARAMS([]);
Asteps=152;
Ssteps=151;
Svals=linspace(0,1,Ssteps);
A=linspace(0,1,Asteps);
cost = 0.1;
hh = figure('Visible','on', 'Name', strcat('OC curves'));

%   S.text(1).name='intrinsic growth rate';
%         S.text(2).name='Carrying Capacity';
%         S.text(3).name='Immigration rate';
%         S.text(4).name='Half saturation constant';
%         S.text(5).name='corr';
%         S.text(6).name='Target State';
%         S.text(7).name='Best Action';
%plotStateVSGrowth()
%doeco()
grothrates = [  1.5 1.0 0.5]
closestTo5AplotANA=[]
Sopt        = 0.55;
for l=1:length(grothrates)
    for m=1:length(ecoFcns)
        ecoFcn = ecoFcns(m);
        
        for j=1:Ssteps % 151 times
            S=linspace(Svals(j),Svals(j),Asteps);
            
            for i=1:length(A) % 152 times
                
                ECO         = E (ecoFcn, 2, S(j)); %fcn, IP.numInputs, stateValues(m)
                ECO.P(1)    = grothrates(l);
                current_s   = ECO.S;
                
                
                ECO         = E (ECO, A(i), current_s, 1);
                newS(j,i)   = ECO.S;
            end
            
            [value index] = sort(abs(newS(j,:) - Sopt), 'ascend');
            [value2 index2] = sort(abs(newS(j,:) - Sopt), 'ascend');

            closestTo5Aplot(j,m) = A(index(1));
            
                gr=grothrates(l);
                KC=1;
                closestTo5AplotANA(j,m) = max(0, 1 + gr*(1-Svals(j)/KC) ...
                                            - (KC+cost)/(2*Svals(j))); % analytical
            s=Svals(j);
         
          closestTo5AplotANAcost2(j,m) = min(max (0, ((1+gr*(1-s/KC) - KC/(s*2))/(0.1/(2*s) +1))), 1); % analytical
            reward(j,m) = s*closestTo5AplotANAcost2(j,m) - ...
                closestTo5AplotANAcost2(j,m)*0.1;
           
            MSE(l) = max(0, 1 + gr*(1-Sopt/KC) ...
                                            - (KC+cost)/(2*Sopt)); 
            SMEY = Sopt;
            MSE2(l) = min(max (0, ((1+gr*(1-SMEY/KC) - KC/(SMEY*2))/(0.1/(2*SMEY) +1))), 1); % analytical
        end
        
    end
   
    %plot(Svals, reward)
    break_point_index = min(find (closestTo5Aplot > 0)) - 1;
    break_point(l) = Svals(break_point_index)
    
    %plotOC(ecoFcns, closestTo5Aplot, MSE, break_point);
    hold on
    plotOC(ecoFcns, closestTo5AplotANA, MSE, break_point );
    %hold on
    %plotOC(ecoFcns, closestTo5AplotANAcost, MSE, break_point );
    hold on
  %  plotOC(ecoFcns, closestTo5AplotANAcost2, MSE2, break_point );
end






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%   F U N C T I O N S %%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% plot state VS Growth - change in state
%%%%%%%%%%%%%%%%%%%%



%%
%%%%%%%%%%%  optimal control curves


    function plotOC(ecoFcns, closestTo5Aplot, MSE, bp)
        
        for k=1:length(ecoFcns)
            
            if strcmp(ecoFcns(k), 'logistic')
                %closestTo5A
                hh=plot( linspace(0,1,length(closestTo5Aplot(:,1))), ...
                    closestTo5Aplot(:,1),'-', 'Color',PP.col_(l,:), 'LineWidth', 1);
                if l == 3
                    legend({'g=1.5' 'g=1.0' 'g=0.5'}, 'Location', 'NorthWest')
                end
                hold on
                %ylim([0 0.7])
                xlabel(['State'], 'FontSize', PP.fontSizeNormal)
                ylabel(['Action'], 'FontSize', PP.fontSizeNormal)
                
                ah=gca;
                set(ah,'FontSize',PP.fontSizeSmall)
                %xtar = text(0.2,0.05,'\beta','FontSize',PP.fontSizeXL4)
                %xtar = text(0.2,0.05,'\beta','FontSize',PP.fontSizeXL4)
                %xtar = text(0.2,0.05,'\beta','FontSize',PP.fontSizeXL4)
                % text(0.01,0.67,'Optimal path of action','FontSize',PP.fontSizeXL4)
                title('Optimal path of action','FontSize',PP.fontSizeXL4b)
                hold on
                
            end
        end
        if l == 3
            plot(Sopt, MSE(1), '*','MarkerSize',14, 'MarkerEdgeColor',PP.col_(1,:));
            plot(Sopt, MSE(2), '*','MarkerSize',14, 'MarkerEdgeColor',PP.col_(2,:));
            plot(Sopt, MSE(3), '*','MarkerSize',14, 'MarkerEdgeColor',PP.col_(3,:));
            
            plot(bp(1), 0, 'd','MarkerSize',8,  'MarkerFaceColor',PP.col_(1,:), 'MarkerEdgeColor',PP.col_(1,:));
            plot(bp(2), 0, 'd','MarkerSize',8, 'MarkerFaceColor',PP.col_(2,:),'MarkerEdgeColor',PP.col_(2,:));
            plot(bp(3), 0, 'd','MarkerSize',8, 'MarkerFaceColor',PP.col_(3,:),'MarkerEdgeColor',PP.col_(3,:));
            
            
            plot([Sopt Sopt],[0 0.7], 'Color', [0.5 0.5 0.5]);
            %saveFigName=['..', filesep, '..', filesep,'..', filesep, '..', filesep,'..', filesep,'latex', filesep, 'figures', filesep, 'OC1' '.eps']
            saveFigName=['..', filesep,'figures', filesep, 'OC1' '.eps']
            saveas(hh, saveFigName,'psc2');
        end
        
    end



    function setParams(fcn)
        % disp('setting parametes')
        
        ECO    = E(fcn, 2, Sopt); %fcn, IP.numInputs, stateValues(m)
        g      = ECO.P(1);
        K      = ECO.P(2);
        I      = ECO.P(3);
        h     = ECO.P(4);%Half saturation constant
        corr   = ECO.P(5);
        
        SoptEfcn=ECO.P(6);
        bestActionE = ECO.P(7);
        
        
        
    end

end

%%

 %     Amsy = max(0, 1 + gr*(1-s/KC) - (KC+(Amsy*s*0.1))/(2*s)); % analytical       







