function []=ProduceData(varargin)
%
in=varargin{1,1};
nrbfs =  in(1,1);
rbfspread = in(1,2);
nseeds = in(1,3);
the_params = in(1,4);
bestonaverage = in(1,5); % find the robust agent
increasing_bestonaverage = in(1,6); % general test for best parameters for increasing trends, not used
temp = in(1,7); % to test low temp not used
single_run = in(1,8); % test robustness of parameter set for optimized scenarios
%clear all
close all
set(0,'DefaultFigureWindowStyle','docked')
headers = {'dr ' 'ss ' 'lr ' 'rbfs ' 'rbfSpreadDiv '  'smtemp ' 'lambda ' 'gaer' 'perfA' 'perfIndex ' 'RL' 'ET' 'Spread'};
[stat, mess] = fileattrib;
dataFolder='Data';
name = strcat('..', filesep, 'AgentVer1', filesep, dataFolder); %strcat(fullfile(mess.Name,'..', filesep ,dataFolder));
% RUN OR TEST
%runSims = {'randoms', 'gaLinspace'};%, 'testLinspace' ]; % 'testRandoms'
runSims = {'gaLinspace'};%, 'testLinspace' ]; % 'testRandoms'
if single_run
    runSims = {'robust'} ;
end
bestParamValuesForLinspace = []; % is set when running testsRandoms
maxNumRoundsGaLinspace = 1;
minError = 0.05;
iGA = 0;
gaError = 0.1;
grc = {   'abDecR'  'linearDec' 'abIncR' 'cos'  'linearInc'   'constant'      'abRand' };
%grc = {   'abIncR'    } % 'abRand' 4.5
%grc = {  'cos'  'abRand' 'abIncR' 'abDecR' };
bpconsta = [ 0.90  0.20  1.0 nrbfs 0.57 0.015  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];% ... % 4.85
bplininc = [ 0.75  0.15  1.0 nrbfs 0.57 0.04   0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
bpabincr = [ 0.62  0.15  1.0 nrbfs 0.57 0.035  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
bpfastco = [ 0.75  0.30  1.0 nrbfs 0.57 0.015   0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
bpabrand = [ 0.65  0.25  1.0 nrbfs 0.57 0.015   0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
bplindec = [ 0.90  0.30  1.0 nrbfs 0.57 0.05   0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
bpabdecr = [ 0.90  0.43  1.0 nrbfs 0.57 0.045  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
% ab dec increased temp to 0.45 from 0.4 others were peaked, ok content
% cos increased lr from 0.2 to 0.25, others peaked: after more exploration
% and less discounting is needed, I start with less discounting from 0.8 to
% 0.75, ok then even higher lr was needed to tesing woth 0.3.
% lin dec, increased lr to 3 from 2.7, was ok but this might decrease the
% temp? yes lowering temp from 0.055 to 0.05, continue to lower temp might
% need to lower update rate again

while iGA < maxNumRoundsGaLinspace && gaError > minError
    iGA = iGA + 1;
    for iTests = 1:size(runSims, 2)
        runSim = runSims{iTests}
        % PRE PAPER: for testing different combinations of parameters
        % only for finding bet params (not for article)
        % only run evaluateMethods8 with this one
        
        params          = the_params;
        
        if strcmp(runSim, 'testRandoms') || strcmp(runSim, 'randoms')
            testRandomSim = true;
            findOptimalParams=0;
            numBestAgents = 20;
        elseif strcmp(runSim, 'testLinspace') || strcmp(runSim, 'linspace') || strcmp(runSim, 'gaLinspace')
            testRandomSim = false;
            if strcmp(runSim, 'testLinspace') || strcmp(runSim, 'gaLinspace')
                findOptimalParams = 0;
                numBestAgents = 1;
            end
        elseif strcmp(runSim, 'robust')
            findOptimalParams = 0;
            numBestAgents = 1;
            testRandomSim=false;
        end
        % PARER: for testing one parameter at a time, Results section for article
        
        
        % PICKUP and OPTIMAL CONTROL - The two introductory figures
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %generateOCDataFiles()
        
        %CreatePickupAndOCMethodsFigures()
        
        %!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        % ################ har dagit bort att statet dippar d? och
        % d?!!!!!!!!!!!!!!!!!!
        
        % 1. Run simulatios pre paper (random combinations) or for paper (linear tests one at a time)
        trainingTypes={'reward' 'OC'};
        trainingTypes={'reward'};
        for tt = 1:size(trainingTypes, 1)
            trainingType = trainingTypes(tt)
            seeds_       = nseeds; %24 + tt;
            
            if strcmp(runSim, 'robust') || strcmp(runSim, 'randoms') || strcmp(runSim, 'gaLinspace')
                ecoFcns_        = {'logistic'};
                %ecoFcns_        = {'logistic'};
                learningType_   = 'unsupervised'; % supervised vs unsupervised
                makePaperPlots_ = 0;
                useRL_          = 1;
                learningRate_   = 1;
                useET           = 1;
                accountForCutTrace  = true;
                doCutTrace          = true;
                useSprimByAgent     = true;
                
                if strcmp(runSim,    'gaLinspace') || strcmp(runSim, 'robust')
                    if iGA == 1
                        
                        if bestonaverage || increasing_bestonaverage% Lambda was 0.001
                            if nrbfs == 81
                                if increasing_bestonaverage
                                    
                                    % increasing scenarios best params
                                    bestovelall =  [ 0.68  0.15   1.0 nrbfs 0.57 0.037  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                else
                                    temp_original=0.045;
                                    bestovelall =  [ 0.875  0.25   1.0 nrbfs 0.57 temp_original  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                end
                            elseif nrbfs == 49
                                bestovelall =  [ 0.9  0.4   1.0 nrbfs 0.57 0.1 0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                
                            elseif nrbfs == 25
                                bestovelall =  [ 0.95  1.0   1.0 nrbfs 0.57 0.06  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                            elseif nrbfs == 4
                                bestovelall =  [ 0.9  0.8   1.0 nrbfs 0.57 0.1 0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                
                            else
                                printit = 'error num RBFs for best on average not set'
                            end
                            
                            bpconsta = bestovelall;
                            bpslowco = bestovelall;
                            bpfastco = bestovelall;
                            bplininc = bestovelall;
                            bpabincr = bestovelall;
                            bplindec = bestovelall;
                            bpabdecr = bestovelall;
                            bpabrand = bestovelall;
                        else
                            if nrbfs == 81
                                %dr ss
                                
                                % lindec temp from 0.5 to 0.55
                                
                                % ab rand increased dr from 0.62 to 0.65, others were somewhat peaked but want temp
                                % to show more strongly (could also try change to 0.6)
                                
                                bpslowco = [ 0.85  0.6   1.0 nrbfs 0.57 0.08   0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %
                            elseif nrbfs == 49
                                %dr ss
                                %                                 bpconsta = [ 0.9   0.65 1.0 nrbfs 0.57 0.05   0.0   1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];% ... % 4.85
                                %                                 bplininc = [ 0.6   0.2 1.0 nrbfs 0.57 0.09  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpabincr = [ 0.6   0.2 1.0 nrbfs 0.57 0.07  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpslowco = [ 0.85  0.6  1.0 nrbfs 0.57 0.08  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpfastco = [ 0.9   0.55  1.0 nrbfs 0.57 0.1  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpabrand = [ 0.45   0.6  1.0 nrbfs 0.57 0.04  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bplindec = [ 0.9   0.5  1.0 nrbfs 0.57 0.05  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpabdecr = [ 0.9   0.7  1.0 nrbfs 0.57 0.05  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %
                            elseif nrbfs == 25
                                %dr ss
                                %bpconsta = [0.95   0.65   1.0 nrbfs 0.57 0.03 0.0   1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];% ... % 4.85
                                %bpslowco = [ 0.7  0.8  1.0 nrbfs 0.57 0.08  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %bpfastco = [ 0.9  1.0  1.0 nrbfs 0.57 0.10  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %bplininc = [ 0.6  0.2  1.0 nrbfs 0.57 0.06  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %bpabincr = [ 0.6  0.3  1.0 nrbfs 0.57 0.07  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %bplindec = [ 0.95  1.1  1.0 nrbfs 0.57 0.10  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %bpabdecr = [ 0.95  1.1  1.0 nrbfs 0.57 0.1  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %bpabrand = [ 0.5  0.9  1.0 nrbfs 0.57 0.04  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                            elseif nrbfs == 4
                                %                                 %dr ss
                                %                                 bpconsta = [ 0.9   0.65 1.0 nrbfs 0.57 0.05   0.0   1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];% ... % 4.85
                                %                                 bplininc = [ 0.6   0.2 1.0 nrbfs 0.57 0.09  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpabincr = [ 0.6   0.2 1.0 nrbfs 0.57 0.1  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpslowco = [ 0.85  0.6  1.0 nrbfs 0.57 0.08  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpfastco = [ 0.9   0.55  1.0 nrbfs 0.57 0.14  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpabrand = [ 0.5   0.55  1.0 nrbfs 0.57 0.04  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bplindec = [ 0.9   0.5  1.0 nrbfs 0.57 0.14  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                %                                 bpabdecr = [ 0.9   0.5  1.0 nrbfs 0.57 0.14  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread];
                                
                            else
                                printit = 'error num RBFs for best on average not set'
                            end
                            
                        end
                    end
                    numClusters = 8;
                    numTrialsPerParam         = 31; % *3X NUM RADBAS  TESTS to account for num radbas tests Hur m?nga tester ex 10000 som vi har i stora testet
                    steps_              = 200; % how many fishing rounds
                    findOptimalParams   = 0; % change to 0 for figures to use in paper, 1 is just for finding the best parameters
                    runsPerDropSeries   = 1; % will be NoStartStates*NoStartAction so no need
                    startStates         = [0.55];
                    startActions        = [0.45 0.45 0.45 ];
                    numBestAgents       = 1;
                   
                    grc_opt=[];
                    param_setups=1;
                end
                if strcmp(runSim, 'robust')
                    numClusters = 8;
                    numTrialsPerParam   = 1; % *3X NUM RADBAS  TESTS to account for num radbas tests Hur m?nga tester ex 10000 som vi har i stora testet
                    steps_              = 200; % how many fishing rounds
                    findOptimalParams   = 0; % change to 0 for figures to use in paper, 1 is just for finding the best parameters
                    runsPerDropSeries   = 1; % will be NoStartStates*NoStartAction so no need
                    startStates         = [0.55];
                    startActions        = [0.45 0.45 0.45 ];
                    numBestAgents       = 1;
                    
                    grc_optmized = {'constant' 'linearInc' 'abIncR' 'cos' 'abRand' 'abDecR' 'linearDec' 'Aggregated' };
                    param_setups=[ ...
                        0.90    0.20   1.0 nrbfs 0.57 0.015  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread;
                        0.75    0.15   1.0 nrbfs 0.57 0.04  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread;
                        0.62    0.15   1.0 nrbfs 0.57 0.035  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread;
                        0.75    0.30   1.0 nrbfs 0.57 0.015  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread;
                        0.65    0.25   1.0 nrbfs 0.57 0.015  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread;
                        0.90    0.43   1.0 nrbfs 0.57 0.045  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread;
                        0.90    0.3    1.0 nrbfs 0.57 0.05  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread;
                        0.875   0.25   1.0 nrbfs 0.57 0.045  0.0  1.0 0.7661 0.0294 1.0000 1.0000 rbfspread;
                        ];
                end
                for iRobust=1:length(param_setups)
                    if strcmp(runSim, 'robust')
                        param_setup = param_setups(iRobust,:)
                        bpconsta = param_setup;
                        bpslowco = param_setup;
                        bpfastco = param_setup;
                        bplininc = param_setup;
                        bpabincr = param_setup;
                        bplindec = param_setup;
                        bpabdecr = param_setup;
                        bpabrand = param_setup;
                        
                        grc_opt=grc_optmized{iRobust};
                    end
                    result_file_name   = startSimulation(numTrialsPerParam, steps_, seeds_, learningType_, ...
                        ecoFcns_, useRL_, makePaperPlots_, learningRate_, params, findOptimalParams, runSim, ...
                        trainingType, accountForCutTrace, doCutTrace, useSprimByAgent,  runsPerDropSeries, ...
                        startStates, startActions, useET, bestParamValuesForLinspace, grc, numClusters, ...
                        bpconsta,   bplininc, bplindec, bpslowco,bpfastco, bpabdecr,bpabincr, bpabrand, grc_opt);
                end
            end
        end
    end
end
end


