function []=ProduceFigures2(varargin)
%
%
%clear all
close all

params= [1 2 6 7 13];
params= [1 2 6];
in=varargin{1,1};
in2=varargin{1,2};
plot_type = in2;%{1,6}
nrbfs =  in(1,1);
rbfspread = in(1,2);
nseeds = in(1,3);
plot_gen_lines = in(1,4); % plot a figure of spread of the generalized agent in each point
nseeds_gen = in(1,5);
start_index_pi = in(1,6);
plot_gen = in(1,7); % plot generalized agent or not
show_fixed_values = in(1,8);
plot_percent= in(1,9);

the_fcn_legends_name = {'Learning Agent (Specialized)'  ...
    'Learning Agent (Robust)' 'Fixed Policy'};
 
%========================================================================================================        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%========================================================================================================

plotPIsAction_      = 0;
plotPIs_            = 0; % plot staples Reward based, specialized + generalized
plotParamsLines_    = 0;            % plotParamsLines as above but lines
plotASR_            = 0;
plotStrategies_     = 0;

if strcmp(plot_type, 'plotPIsAction_')
    plotPIsAction_      = 1; %a_mae_ou
elseif strcmp(plot_type, 'plotPIs_') || strcmp(plot_type, 'plotPIsPPT_')
    plotPIs_            = 1; % plot staples Reward based, specialized + generalized
elseif strcmp(plot_type, 'plotParamsLines_')
    plotParamsLines_    = 1;            % plotParamsLines as above but lines
elseif strcmp(plot_type, 'plotASR_')
    plotASR_             = 1;
elseif strcmp(plot_type, 'plotStrategies_')
    plotStrategies_   = 1;
end
%========================================================================================================
%========================================================================================================
set(0,'DefaultFigureWindowStyle','docked')
headers = {'dr ' 'ss ' 'lr ' 'rbfs ' 'rbfSpreadDiv '  'smtemp ' 'lambda ' 'gaer' 'perfA' 'perfIndex ' 'RL' 'ET' 'Spread'};
[stat, mess] = fileattrib;
dataFolder='Data';

plotParameterChangeLabels = {'A) Discount Factor', 'B) Learning Rate', 'Learning Rate NN', 'RBFs' ...
    'Spread Divisor', 'C) Exploration Level', 'C) Hindsight','gaer' ,'PIA', 'PIR','USERL', 'USEET', 'Spread (Level of Generalization)'};
%
%grc = {  'constant' 'linearInc' 'abIncR' 'cos'  'abRand' 'abDecR' 'linearDec' };
grc = {  'constant' 'linearInc' 'abIncR' 'cos'  'abRand' 'linearDec'  'abDecR' };

PP=PLOTPARAMS([]);
steps = 200;
growthRateChangePerGrc = zeros(1, steps);
if plotASR_
    if plot_gen_lines == 1
        fcns = { 'logisticGeneralRew'};
    else
        fcns = { 'logisticSpecRew'};
    end
elseif plotPIsAction_
    fcns = { 'logisticSpecAct' 'logisticGeneralAct' 'logisticStaticAct' };
    savePIas = '../../../latex/figures/resultsPIActionZ.eps'; % logisticB
    fcnsLegend = the_fcn_legends_name;
    % elseif plotParams_
    %     fcns = { 'logistic' };
    %     saveasimg = '../../../latex/figures/resultsParsZ.eps';
elseif plotParamsLines_
    fcns = { 'logisticSpecRew',  'logisticGeneralRew'  };
    saveasimg = '../../../latex/submit_RSPB_minor_revision/paramsRevised';
    if plot_gen_lines
        fcns = { 'logisticGeneralRew' ,  'logisticGeneralRew' };
        saveasimg = '../../../latex/submit_RSPB_minor_revision/paramsRevisedGen';
        savePIas = '../../../latex/figures/submit_RSPB_minor_revision/resultsParsLinesZ_PI';
    end
elseif plotPIs_
    fcns = {'logisticSpecRew' 'logisticGeneralRew' 'logisticStaticRew' };
    if strcmp(plot_type, 'plotPIsPPT_')
        savePIas = '../../../latex/submit_RSPB_minor_revision/resultsPIANA_PPTZ_PPT.eps'; % logistic + logisticC
    elseif plot_gen == 0
        savePIas = '../../../latex/submit_RSPB_minor_revision/resultsPIrew.eps'; % logistic + logisticC
    elseif plot_gen == 1
        savePIas = '../../../latex/submit_RSPB_minor_revision/resultsPIrew.eps'; % logistic + logisticC
    elseif plot_gen == 2
        savePIas = '../../../latex/submit_RSPB_minor_revision/resultsPIlearningVSprecautionary.eps'; % logistic + logisticC
        
    end
    
    fcnsLegend = {'Learning Agent'  'Static Agent'};
elseif plotStrategies_
    fcns = {'logisticSpecRew' 'logisticGeneralRew'}; % need both to calc Robust
    saveasimg = '../../../latex/figures/resultsPIstrategies.eps'; % logistic + logisticC
end

pathName            = strcat('..', filesep, dataFolder, filesep);%strcat(mess.Name, filesep, 'Data', filesep);
pathNameSave        = strcat('..', filesep, '..', filesep, '..', filesep, 'latex', filesep, 'figures', filesep);
% pathNameSaveRandoms = strcat('..', filesep,'..', filesep, 'figures', filesep);

% -------  R E A D filenames .----------

for i_grc = 1:length(grc)
    grcFcn = grc{i_grc}
    setGRCchange(grcFcn, steps);
    learning_SPECIALIZED_File = ... %strcat(num2str(nrbfs),'LData_NR_31_NS_200_Seeds_45_p_');
        strcat(num2str(nrbfs),'LData_NR_31_NS_200_Seeds_',num2str(nseeds), '_p_')
    learning_GENERALIZED_File = ... %strcat(num2str(nrbfs),'LData_NR_31_NS_200_Seeds_25_p_');
        strcat(num2str(nrbfs),'LData_NR_31_NS_200_Seeds_',num2str(nseeds_gen), '_p_')
    staticfile = '81LData_NR_31_NS_200_Seeds_48_p_';    
       % '49LData_NR_31_NS_200_Seeds_20_p_';    
    pi_measure = cell(1, length(fcns));
    result_file_name = char(zeros(length(params), length(fcns)));
    for i_fcn=1:length(fcns)
        
        if strcmp(fcns(i_fcn), 'logisticSpecRew')
            pathNameF       = strcat(pathName, 'unsupervisedlogistic', filesep, grcFcn, filesep);
            %pathNameSaveF   = strcat('unsupervisedlogistic_', grcFcn);
            pathNameSaveF   = strcat('unsupervisedlogistic');
            result_file_name = learning_SPECIALIZED_File;
            pi_measure{i_fcn} = 'r_rel';
            
        elseif strcmp(fcns(i_fcn), 'logisticGeneralRew')
            pathNameF       = strcat(pathName, 'unsupervisedlogistic', filesep, grcFcn, filesep);
            pathNameSaveF   = strcat('unsupervisedlogistic');
            result_file_name = learning_GENERALIZED_File;
            pi_measure{i_fcn} = 'r_rel';
        elseif strcmp(fcns(i_fcn), 'logisticStaticRew')
            pathNameF       = strcat(pathName, 'unsupervisedlogistic', filesep, grcFcn, filesep);
            pathNameSaveF   = strcat('unsupervisedlogistic');
            result_file_name = staticfile;
            pi_measure{i_fcn} = 'r_rel';
        elseif strcmp(fcns(i_fcn), 'logisticGeneralAct')
            pathNameF       = strcat(pathName, 'unsupervisedlogistic', filesep, grcFcn, filesep);
            pathNameSaveF   = strcat('unsupervisedlogistic');
            result_file_name = learning_GENERALIZED_File;
            pi_measure{i_fcn} = 'a_rel';
        elseif strcmp(fcns(i_fcn), 'logisticSpecAct')
            pathNameF       = strcat(pathName, 'unsupervisedlogistic', filesep, grcFcn, filesep);
            pathNameSaveF   = strcat('unsupervisedlogistic');
            result_file_name = learning_SPECIALIZED_File;
            pi_measure{i_fcn} = 'a_rel';
        elseif strcmp(fcns(i_fcn), 'logisticStaticAct')
            pathNameF       = strcat(pathName, 'unsupervisedlogistic', filesep, grcFcn, filesep);
            pathNameSaveF   = strcat('unsupervisedlogistic');
            result_file_name = staticfile;
            pi_measure{i_fcn} = 'a_rel';
        end
        
        
        for i_param=1:length(params)
            pathNameX               = {(strcat(pathNameF, result_file_name, num2str(params(i_param)), '.mat'))};
            % pathNameSaveX           = {(strcat(pathNameSave, pathNameSaveF, '_Data_p_', num2str(params(j))))};
            pathNameSaveX           = {(strcat(pathNameSave,grcFcn, filesep,pathNameSaveF, strcat(num2str(nrbfs),'_Data_p_', num2str(params(i_param)))))};
            result_file_names(i_param,i_fcn)  = pathNameX;
            saveFileNames(i_param,i_fcn)      = pathNameSaveX;
            filehandle1 = result_file_names(i_param,i_fcn);
            %filehandle2 = open(filehandle1{1,1});
        end
    end % end fcns, policy types specialized, general, static
    
    % ------- C A L L external functions to plot figures
    
    size_filenames      = size(result_file_names);
    %     nRows               = size_filenames(1,1);
    %     nCols               = size_filenames(1,2);
    %     paramsWHighestPI    = [];
    %
    %
    %     calcPIAndPars = true;
    
    
    for i_fcn=1:length(fcns)
        filehandle= open (result_file_names {1,i_fcn});
        loadedParams    = filehandle.paramValues;
        loadedPCol1 = loadedParams(:,1);
        filehandle2= strcat(result_file_names (1,i_fcn));
        [outPar1, outPI1, piVec, fixedParamValue, outPI1std, outPI1median] =  ...
            getPI2(filehandle2, 1, pi_measure(i_fcn), ...
            start_index_pi, grc(i_grc));
        
        Par1(i_grc,i_fcn, :) = outPar1;
        PI1(i_grc,i_fcn) = outPI1;
        PI1std(i_grc,i_fcn) = outPI1std;
        PI1median(i_grc,i_fcn) = outPI1median;
        piMat1(i_grc,i_fcn,:) = piVec;
        fixedParamValues1(i_grc,i_fcn,:) = fixedParamValue;
        
        filehandle=open (result_file_names {2,i_fcn});
        loadedParams= filehandle.paramValues;
        loadedPCol2 = loadedParams(:,2);
        filehandle2= strcat(result_file_names (2,i_fcn));
        [outPar2, outPI2, piVec, fixedParamValue, outPI2std, outPI2median] = ...
            getPI2(filehandle2, 2, pi_measure(i_fcn), ...
            start_index_pi,grc(i_grc));
        
        Par2(i_grc,i_fcn,:) = outPar2;
        PI2(i_grc,i_fcn) = outPI2;
        PI2std(i_grc,i_fcn) = outPI2std;
        PI2median(i_grc,i_fcn) = outPI2median;
        piMat2(i_grc,i_fcn,:) = piVec;
        fixedParamValues2(i_grc,i_fcn,:) = fixedParamValue;
        
        filehandle=open (result_file_names {3,i_fcn});
        loadedParams    = filehandle.paramValues;
        if i_fcn == 1
            loadedPCol6 = loadedParams(:,6);
        end
        filehandle2= strcat(result_file_names (3,i_fcn));
        [outPar6, outPI6,   piVec, fixedParamValue, outPI6std, outPI6median] = ...
            getPI2(filehandle2, 6, pi_measure(i_fcn),...
            start_index_pi, grc(i_grc));
        
        Par6(i_grc,i_fcn,:) = outPar6;
        PI6(i_grc,i_fcn) = outPI6;
        PI6std(i_grc,i_fcn) = outPI6std;
        PI6median(i_grc,i_fcn) = outPI6median;
        piMat6(i_grc,i_fcn,:) = piVec;
        fixedParamValues6(i_grc,i_fcn,:) = fixedParamValue;
        
        if find (params == 7)
            filehandle=open (result_file_names {4,i_fcn});
            loadedParams    = filehandle.paramValues;
            loadedPCol7 = loadedParams(:,7);
            filehandle2= strcat(result_file_names (4,i_fcn));
            [outPar7, outPI7,   piVec, fixedParamValue, outPI7std, outPI7median] = ...
                getPI2(filehandle2, 7, pi_measure(i_fcn),...
                start_index_pi, grc(i_grc));
            
            Par7(i_grc,i_fcn,:) = outPar7;
            PI7(i_grc,i_fcn) = outPI7;
            PI7std(i_grc,i_fcn) = outPI7std;
            PI7median(i_grc,i_fcn) = outPI7median;
            piMat7(i_grc,i_fcn,:) = piVec;
            fixedParamValues7(i_grc,i_fcn,:) = fixedParamValue;
        else
            piMat7 = [];
            loadedPCol7=[];
            fixedParamValues7 = [];
        end
        
        if find (params == 13)
            filehandle = open (result_file_names {5,i_fcn});
            loadedParams    = filehandle.paramValues;
            loadedPCol13 = loadedParams(:,13);
            filehandle2= strcat(result_file_names (5,i_fcn));
            [outPar13, outPI13,   piVec, fixedParamValue, outPI13std, outPI13median] = ...
                getPI2(filehandle2, 13, pi_measure(i_fcn),start_index_pi, grc(i_grc));
            
            Par13(i_grc,i_fcn,:) = outPar13;
            PI13(i_grc,i_fcn) = outPI13;
            PI13std(i_grc,i_fcn) = outPI13std;
            PI13median(i_grc,i_fcn) = outPI13median;
            piMat13(i_grc,i_fcn,:) = piVec;
            fixedParamValues13(i_grc,i_fcn,:) = fixedParamValue;
        else
            piMat13 = [];
            loadedPCol13 = [];
            fixedParamValues13 = [];
        end
        
        for iPars=1:length(params)
            
            if plotASR_
                plotASR(piMat1, piMat2, piMat6,  piMat7, piMat13,...
                    params(iPars), result_file_names, PP, saveFileNames, i_grc)
                
            end
        end
    end % fcns specialized, general, static
    clear result_file_names saveFileNames
end % end grcs the 7 environmental change

if plotPIs_
    plotPIs(PI1, PI2,PI6, plot_type, plot_gen, PP, grc, savePIas, ...
        plot_percent, PI1std, PI2std,PI6std, PI1median, PI2median,PI6median)%, PI7, PI13)
end
if plotPIsAction_
    plotPIsAction(PI1, PI2,PI6, plot_type, plot_gen, PP, grc, savePIas, fcnsLegend)
end

% if plotParams_
%     plotParams(Par1(:,1), Par2(:,1), Par6(:,1), Par7(:,1), Par13(:,1),...
%         indexes1, indexes2, indexes6, indexes7, indexes13, ...
%         values1, values2, values6, values7, values13)
% end
if plotParamsLines_
    plotParamsLines(piMat1, piMat2, piMat6,  piMat7, piMat13, PP, grc, ...
        loadedPCol1,loadedPCol2,loadedPCol6,loadedPCol7, loadedPCol13, ...
        PI1, PI2,PI6,...
        fixedParamValues1, fixedParamValues2, fixedParamValues6, ...
        fixedParamValues7, fixedParamValues13, ...
        plotParameterChangeLabels, saveasimg, show_fixed_values)
end
if plotStrategies_
    plotStrategies(fixedParamValues1, fixedParamValues2, fixedParamValues6, ...
        plot_type, plot_gen, PP, grc, saveasimg)%, PI7, PI13)
end

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ---------------- F U N C T I O N S ------------------------------------%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plotStrategies(PI1, PI2,PI6, plot_type, plot_gen, PP, grc, saveasimg)
% create matrix for values to show in paper
K1=0.7;
fig_handlePI   = figure('Visible','on', 'Name', strcat('Strategies'));
bar_data= ([PI1(:,1) PI2(:,1) PI6(:,1).*10 ]);
bar_data(length(PI1) + 1, 1) = PI1(1,2);
bar_data(length(PI2) + 1, 2) = PI2(1,2);
bar_data(length(PI6) + 1, 3) = PI6(1,2).*10;
%normalize temperature data
%bar_data(:,1) = bar_data(:,1) / max(bar_data(:,1));
%bar_data(:,2) = bar_data(:,2) / max(bar_data(:,2));
%bar_data(:,3) = bar_data(:,3) / max(bar_data(:,3));
%y = [2 2 3; 2 5 6; 2 8 9; 2 11 12];
% x=linspace(1,15,8)
% x2=linspace(2,16,8)
% y1=bar_data(:,1:2)
% y2=bar_data(:,2)
% y3=bar_data(:,3)
% x=linspace(1,8,8)
% offset = (x(2)-x(1))/24;
% xd=[linspace(1,8,8)-offset-offset; linspace(1,8,8)-offset]'
%
%
% width = 0.1;
% colors = {'r','g','b'};
%
% %// Do the plot
% plotyy(xd,y1,x+offset,y3,...
%     @(xd,y1) bar(xd,y1,width),...
%     @(x,y3) bar(x,y3,width/2,colors{3}));
%
% legend('1','2','3')
%h = plotyy(x-offset,y1,x+offset,y2, @(x,y) bar(x,y,width,colors{1}), @(x,y) bar(x,y,width,colors{2}));
%set(h,'xtick',x)
%y1=
%plotyy(x, y1, x+1, y3, 'bar')
my_bar = bar(bar_data,'grouped');
%my_bar = pie(bar_data)
%mycolormap=[PP.col_(2,:);PP.col_(1,:);PP.col_(3,:)];
colormap (fig_handlePI, autumn)  % Change the color scheme
set(my_bar,'BarWidth', K1);
fcnsLegend2 = {'Discount F.','Learning R.','Exploration L.*10'};
y_label = 'Parameter Value';
titleText1 = 'Optimal strategies';
ylabel(y_label, 'FontSize', PP.pi_legend_font_size+2)

newgrcLabels = cell(1,length(grc));
newgrcLabels=setGRClegendNames(grc);

newgrcLabels{length(newgrcLabels) + 1} = 'Aggreg. Set';
newgrcLabelsx = strcat('Opt. [', newgrcLabels,']')
% Example input:
% matrix = [1.5 1.764; 3.523 0.2];
columnLabelsLatex  = {'Disc. F.', 'Lear. R.', 'Exp. L.*10' };

% note this call is removed for l i c  reasons matrix2latex(bar_data,  '../tables/OptimalPolicyParameters.txt',...
%    'rowLabels', newgrcLabelsx, 'columnLabels', columnLabelsLatex, ...
%    'size', 'small');%, ...

%legend_position = 'NorthOutside';
legend(fcnsLegend2, 'Orientation', 'horizontal','Location', 'NorthOutside')
%legend('Orientation', 'horizontal')
%legend('Location', legend_position)
legend('boxoff')
x_label_text = 'Optimal Strategy per Scenario'
xlabel(x_label_text,'FontSize', PP.pi_legend_font_size+2)
set(gca,'XTickLabel',newgrcLabelsx,...
    'FontSize', PP.pi_legend_font_size)
xticklabel_rotate([],45)
grid off;
y_lim_max = max(sum(bar_data, 2));
ylim([0 0.92])

saveas(fig_handlePI, saveasimg,'psc2');
hold off
clear fig_handlePI mycolormap saveasimg

end

function plotASR(piMat1, piMat2, piMat6, piMat7, piMat13, ...
    param, result_file_names, PP, saveFileNames, iGrc )
h   = figure('Visible','on', 'Name', strcat('ASR'));


if param == 1
    file_id = 1;
    [pimat1_max, index_max] = max(piMat1(iGrc, :,:), [], 3)
elseif param == 2
    file_id = 2;
    [pimat1_max, index_max] = max(piMat2(iGrc, :,:), [], 3)
elseif param == 6
    file_id = 3;
    [pimat1_max, index_max] = max(piMat6(iGrc, :,:), [], 3)
elseif param == 7
    file_id = 4;
    [pimat1_max, index_max] = max(piMat7(iGrc, :,:), [], 3)
elseif param == 13
    file_id = 5;
    [pimat1_max, index_max] = max(piMat13(iGrc, :,:), [], 3)
    
    
end

filehandle      = open (result_file_names{file_id});
loadedAnResult  = filehandle.anResult;
%         loadedResult    = filehandle.tmpResult;
loadedResultComp= filehandle.result;
loadedParams    = filehandle.paramValues;

e_res = loadedResultComp{index_max,6};
a_res = loadedResultComp{index_max,7};
s_res = loadedResultComp{index_max,8};
r_res = loadedResultComp{index_max,9};


e_ana = loadedAnResult{1,6};
a_ana = loadedAnResult{1,7};
s_ana = loadedAnResult{1,8};
r_ana = loadedAnResult{1,9};

%[dr ss lr rbfs rbf_spread_div smtemp lambda gaer perforAIndex perforIndex useRL useET];
numrowsplot = 1;%numrowscolssize(1,1);

rows=3;
cols=1;

linewidth = 2;
s = size(a_res);
nRws=s(1,1);
nCls=s(1,2);

% ------- ACTION

subplot(rows,cols,1)
hold on
a_ana_plot = sum(a_ana, 1) ./ nRws;
%a_ana_plot = a_ana(1,:)
plot(linspace(1,nCls,nCls), a_ana_plot, '-', 'Color', PP.colBlackish, 'Linewidth', linewidth )
a_res_plot = sum(a_res, 1) ./ nRws;
%a_res_plot = a_res(1,:)
plot(linspace(1,nCls,nCls), a_res_plot, '-', 'Color', PP.col_(1,:), 'Linewidth', linewidth)
legend({'Optimal Control' 'Agent (Spec. Str.)'}, 'Location', 'NorthWest')
ylabel(['Act.'], 'FontSize',PP.fontSizeNormal)
ylim([0 1.0])
% ------- STATE -----------------------------------
subplot(rows,cols,2)
hold on
s_ana_plot = sum(s_ana, 1) ./ nRws;
%s_ana_plot = s_ana(1,:)
plot(linspace(1,nCls,nCls), s_ana_plot, '-', 'Color', PP.colBlackish , 'Linewidth', linewidth)
s_res_plot = sum(s_res, 1) ./ nRws;
%s_res_plot = s_res(1,:);
plot(linspace(1,nCls,nCls), s_res_plot, '-', 'Color', PP.col_(1,:), 'Linewidth', linewidth)
ylabel(['St.'], 'FontSize',PP.fontSizeNormal)
ylim([0 1.0])
% ------ REWARD -----------------------------------
subplot(rows,cols,3)
hold on
r_ana_plot = sum(r_ana, 1) ./ nRws;
%r_ana_plot = r_ana(1,:)
plot(linspace(1,nCls,nCls), r_ana_plot, '-', 'Color', PP.colBlackish , 'Linewidth', linewidth)
r_res_plot = sum(r_res, 1) ./ nRws;
%r_res_plot = r_res(1,:)
plot(linspace(1,nCls,nCls), r_res_plot, '-', 'Color', PP.col_(1 ,:), 'Linewidth', linewidth)
ylabel(['Rew.' ], 'FontSize',PP.fontSizeNormal)
ylim([-0.1 0.4])


% ------ exploration -----------------------------------
% subplot(rows,cols,4)
% hold on
%
%
% min_val = abs(min(e_res, 2));
% e_res1 = mean(e_res + repmat(min_val, size(e_res)))
% e_res2 = e_res1 - min_val;
% e_res_plot = e_res2;%mean(abs(e_res(:,:)));
% plot(linspace(1,nCls,nCls), e_res_plot, '-', 'Color', PP.col_(1 ,:), 'Linewidth', linewidth)
% ylabel(['Expl.' ], 'FontSize',PP.fontSizeNormal)
% ylim([-0.1 0.1])
% num_explorations = length (find (abs(e_res_plot) > 0))
% average_exploration = sum(abs(e_res_plot)) / num_explorations
%------------ END exploration

saveFigName=char(strcat(saveFileNames{file_id}, 'ASRx.eps')); %to save for actual paper add x
saveas(h, saveFigName,'psc2');

end

%% plotParamsLines %%%%%%%%%%%%%%%%%%%
function plotParamsLines(piMat1, piMat2, piMat6, piMat7, piMat13, PP, grc, ...
    loadedPCol1,loadedPCol2,loadedPCol6,loadedPCol7, loadedPCol13, ...
    PI1, PI2,PI6,...
    fixedParamValues1, fixedParamValues2, fixedParamValues6, ...
    fixedParamValues7, fixedParamValues13, ...
    plotParameterChangeLabels, saveasimg, show_fixed_values)

K=1;
yRows = 2;
xCols = 2;
titleFontSize = PP.title_font_size;
fw = 'normal';
ylim_min = 0.7;
mycolormap=[PP.col_(2,:);PP.col_(1,:);PP.col_(3,:)] ;%[0.2 0.7 0.2]] ;
scenariocolors  = {PP.col2_(4,:), PP.col2_(2,:), ...
    PP.col2_(2,:), PP.col2_(5,:),...
    PP.col2_(5,:), PP.col2_(1,:), ...
    PP.col2_(1,:)};
scenariomarkers = {'d','o', '+', 'o', '+', 'o', '+'};
theMarkerSize = 6;
%scenariomarkers = {'.','.', '.', '.', '.', '.', '.'};
%scenarioMarkerFaceColor = scenariocolors;
robust_name = 'Averaged';
tex_pos=[0.95 0.95 0.7]
vertical_line_type= '--';
mean_robust_line = '-.'
mean_robust_color = 'k';
theLineWidth = 1.5;
thethin = 1;
%theLineStyle = {'-', '-', '--', '-', '--', '--', '-'}
theLineStyle = {'-', '-', '-', '-', '-', '-', '-'}

% show_fixed_values = false
%%% 1 discount factor  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% subaxis(yRows, xCols, 2,  'SpacingVert', SpacingV,'SpacingHoriz',SpacingH,'MarginRight', MarginV, 'MarginTop', MarginTopT, 'Padding', padding, 'Holdaxis', true);
plotParam = 1;
strategy  = 1;
fig_handlePars   = figure('Visible','on', 'Name', strcat('Environmental Change')); 
axis([0 9 0 1.1])
for jj=1:length(grc)
    
    plot (loadedPCol1, squeeze(piMat1(jj,strategy,:)) , ...
        scenariomarkers{jj}, ...
            'Color', scenariocolors{jj}, ...
            'LineWidth',theLineWidth, ...
            'MarkerSize', theMarkerSize);
    hold on
    clear data
end
if show_fixed_values
    gen_strategy = 2;
    average_sum = mean(squeeze(piMat1(:,gen_strategy, :)))
    average_sum1 = mean(squeeze(piMat1(:,1, :)))
    plot (loadedPCol1, average_sum, mean_robust_line, 'Color', mean_robust_color, ...
        'LineWidth',theLineWidth)
    %hold on
    %plot (loadedPCol1, average_sum1, '--b')
end
%old legend place

fixedParamValues1(6,1) = fixedParamValues1(6,1)-0.007;
fixedParamValues1(7,1) = fixedParamValues1(7,1)+0.007;
fixedParamValues1(4,1) = fixedParamValues1(4,1)+0.007;
for jj=1:length(grc)
    if (strcmp(grc{jj}, 'abDecR') || strcmp(grc{jj}, 'linearDec'))
        smoothnessParam = 0.3;
    else
        smoothnessParam = 1.5;
    end
    
    smoothedCurve = smoothn(squeeze(piMat1(jj,strategy,:)), smoothnessParam);
    plot(loadedPCol1, smoothedCurve, 'Color', scenariocolors{jj}, ...
        'LineWidth',theLineWidth, 'LineStyle', theLineStyle{jj});
    hold on
    % vertical lines for best values
    if show_fixed_values
        %fixedParamValues1(7,1) = fixedParamValues1(7,1)+0.003;

        plot ([fixedParamValues1(jj, 1) fixedParamValues1(jj, 1)], [0 1], ...
            'LineWidth',thethin, ...
            'LineStyle' ,vertical_line_type, 'Color', scenariocolors{jj}, ...
            'Marker', scenariomarkers{jj})
    end
end
plot ([fixedParamValues1(jj, 2) fixedParamValues1(jj, 2)], [0 1], ...
     'LineWidth',thethin , ...
    'LineStyle', vertical_line_type, 'Color', mean_robust_color)
% new place
legend_names = setGRClegendNames(grc);
legend_names{1, length(legend_names) + 1} = robust_name;
h_legend=legend(legend_names, 'Location', 'NorthWest')

set(h_legend,'FontSize',14);
legend('boxoff')
hold on
%xTicklabel('FontSize', 20);
% sets all font to this size, captures the tick marl label size
set(gca,'FontSize',16)
%grid on
ylabel(PP.y_label_param_lines, 'FontSize', PP.label_font_size+2)
xlabel(PP.x_label_param_lines_df, 'FontSize', PP.label_font_size+2)
titleText = plotParameterChangeLabels{plotParam};
ylim([ylim_min 1]);
text (tex_pos(1), 0.99, 'A', 'FontSize', titleFontSize,'FontWeight', 'bold')
%title(titleText,'FontSize', titleFontSize, 'FontWeight', fw)
saveas(fig_handlePars, strcat(saveasimg, num2str(plotParam), '.eps'),'epsc');



%%%%%%%%2 update rate %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%subaxis(yRows, xCols, 1, 'SpacingVert', SpacingV,'SpacingHoriz',SpacingH,'MarginRight', MarginV, 'MarginTop', MarginTopT, 'Padding', padding, 'Holdaxis', true)

plotParam = 2;
fig_handlePars   = figure('Visible','on', 'Name', strcat('Environmental Change'));

%xlab = ['0.0'; '   '; '   '; '0.1'; '   '; '   '; '0.2'; '   '; '   '; '0.3'; '   '; '   '; '0.4'; '   '; '   '; '0.5'; '   '; '   '; '0.6'; '   '; '   '; '0.7'; '   '; '   '; '0.8'; '   '; '   '; '0.9'; '   '; '   '; '1.0'; '   '; '   '; '1.1'; '   '; '   '; '1.2'];

for jj=1:length(grc)
    
    plot (loadedPCol2,squeeze(piMat2(jj,strategy, :)), ...
        scenariomarkers{jj}, ...
        'Color', scenariocolors{jj}, ...
        'LineWidth',theLineWidth, ...
        'MarkerSize',theMarkerSize);
    hold on
end

if show_fixed_values
    gen_strategy = 2;
    average_sum = mean(squeeze(piMat2(:,gen_strategy, :)))
    average_sum1 = mean(squeeze(piMat2(:,1, :)))
    plot (loadedPCol2, average_sum,  mean_robust_line, 'Color', mean_robust_color, ...
        'LineWidth', theLineWidth, 'LineStyle', mean_robust_line)%theLineStyle{jj})
    %hold on
    %plot (loadedPCol2, average_sum1, '--b')
end
%legend_names = setGRClegendNames(grc);
%legend_names{1, length(legend_names) + 1} = robust_name;
%h_legend=legend(legend_names, 'Location', 'NorthEast')
%set(h_legend,'FontSize',14);
fixedParamValues2(2,1) = fixedParamValues2(2,1)+0.007;
fixedParamValues2(4,1) = fixedParamValues2(4,1)+0.007;
fixedParamValues2(5,1) = fixedParamValues2(5,1)+0.007;
  
for jj=1:length(grc)
    
    if (strcmp(grc{jj}, 'abIncR') || strcmp(grc{jj}, 'constant'))
        smoothnessParam = 3;
    else
        smoothnessParam = 1.0;
    end
    dont_smooth = 0;
    if (strcmp(grc{jj}, 'abIncR') || strcmp(grc{jj}, 'linearInc') )
        dont_smooth = 8;
    end
    smoothedCurve = smoothn(squeeze(piMat2(jj,strategy,2:length(piMat2)-dont_smooth)), ...
        smoothnessParam);
    
    plot(loadedPCol2(2:length(loadedPCol2)-dont_smooth), ...
        smoothedCurve, 'Color', scenariocolors{jj}, 'LineWidth',theLineWidth, ...
        'LineStyle', theLineStyle{jj});
    hold on
    if show_fixed_values
        % fix so that lines are not on top of each other
        plot ([fixedParamValues2(jj, 1) fixedParamValues2(jj, 1)], [0 1], ...
            vertical_line_type, 'Color', scenariocolors{jj}, 'LineWidth',thethin, ...
            'Marker', scenariomarkers{jj}, 'MarkerSize', theMarkerSize)
    end
end
plot ([fixedParamValues2(jj, 2) fixedParamValues2(jj, 2)], [0 1], ...
    vertical_line_type, 'Color', mean_robust_color, 'LineWidth',theLineWidth)%, 'LineWidth',theLineWidth, ...
    %'LineStyle', theLineStyle{jj})

%grid on

for jj=1:length(grc)
    plot(loadedPCol2(1:2), squeeze(piMat2(jj,strategy,1:2)), ...
        'Color', scenariocolors{jj}, 'LineWidth',theLineWidth, ...
        'LineStyle', theLineStyle{jj});
end

%%% plot line of all values smached together to find best on average

hold on


set(gca,'FontSize',16)
xlabel(PP.x_label_param_lines_ur, 'FontSize', PP.label_font_size+2)
ylabel(PP.y_label_param_lines, 'FontSize', PP.label_font_size+2)

titleText = plotParameterChangeLabels{plotParam};
ylim([ylim_min 1]);
%title(titleText,'FontSize', titleFontSize, 'FontWeight', fw)
text (tex_pos(2), 0.99, 'B', 'FontSize', titleFontSize,'FontWeight', 'bold')
saveas(fig_handlePars, strcat(saveasimg, num2str(plotParam), '.eps'),'epsc');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% TEMPERATURE 6 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% subaxis(yRows, xCols, 4, 'SpacingVert', SpacingV,'SpacingHoriz',-0.03,'MarginRight', MarginV, 'MarginTop', MarginTopT, 'Padding', padding, 'PaddingLeft', 0,'Holdaxis', true);
fig_handlePars   = figure('Visible','on', 'Name', strcat('Environmental Change'));

plotParam = 6;

% plot the points
for jj=1:length(grc)
    plot (loadedPCol6, squeeze(piMat6(jj,strategy,:)), ...
        scenariomarkers{jj},...
        'Color', scenariocolors{jj},...
          'LineWidth',theLineWidth, ...
        'MarkerSize',theMarkerSize)
    hold on
end
if show_fixed_values
    gen_strategy = 2;
    average_sum = mean(squeeze(piMat6(:,gen_strategy, :)))
    average_sum1 = mean(squeeze(piMat6(:,1, :)))
    plot (loadedPCol6, average_sum,  mean_robust_line, ...
        'Color', mean_robust_color, 'LineWidth', theLineWidth)
    %hold on
    %plot (loadedPCol6, average_sum1, '--b')
end
%legend_names = setGRClegendNames(grc);
%legend_names{1, length(legend_names) + 1} = robust_name;
%h_legend=legend(legend_names, 'Location', 'SouthWest')
%set(h_legend,'FontSize',14);
fixedParamValues6(4,1) = fixedParamValues6(4,1)-0.001
fixedParamValues6(5,1) = fixedParamValues6(5,1)+0.0018
fixedParamValues6(7,1) = fixedParamValues6(7,1)+0.0011
      
for jj=1:length(grc)
    
    smoothnessParam = 1.5;
    smoothedCurve = smoothn(squeeze(piMat6(jj,strategy,:)), smoothnessParam);
    plot(loadedPCol6, smoothedCurve, 'Color', scenariocolors{jj}, ...
        'LineWidth',theLineWidth, 'LineStyle', theLineStyle{jj});
    hold on
    % plot the vertical lines with markers on top
    if show_fixed_values
         plot ([fixedParamValues6(jj, 1) fixedParamValues6(jj, 1)], [0 1], ...
            'LineWidth',thethin, 'LineStyle',vertical_line_type,  'Color', scenariocolors{jj}, ...
            'Marker', scenariomarkers{jj},  'MarkerSize', theMarkerSize, ...
        'Linewidth', thethin) 
           
            
            
    end
end

plot ([fixedParamValues6(jj, 2) fixedParamValues6(jj, 2)], [0 1], ...
    'LineWidth',thethin, 'LineStyle',vertical_line_type, 'Color', mean_robust_color)%, 'LineWidth',thethin)%, ...
    %'LineWidth',theLineWidth, 'LineStyle', theLineStyle{jj})
hold on

%grid on
set(gca,'FontSize',16)
ylabel(PP.y_label_param_lines, 'FontSize', PP.label_font_size+2)
%ylabel(' ', 'FontSize', PP.label_font_size+2)
xlabel(PP.x_label_param_lines_el, 'FontSize', PP.label_font_size+2)
ylim([ylim_min 1]);
xlim([min(loadedPCol6) max(loadedPCol6)])
set(gca,'Xscale', 'log');
titleText = plotParameterChangeLabels{plotParam};
text (tex_pos(3), 0.99, 'C', 'FontSize', titleFontSize,'FontWeight', 'bold')
%title(titleText,'FontSize', titleFontSize, 'FontWeight', fw);
saveas(fig_handlePars, strcat(saveasimg, num2str(plotParam), '.eps'),'epsc');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 7 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (length(piMat7) > 1)
    plotParam = 7;
    
    fig_handlePars   = figure('Visible','on', 'Name', strcat('Environmental Change'));
    for jj=1:length(grc)
        plot (loadedPCol7, squeeze(piMat7(jj,strategy,:)), scenariomarkers{jj}, 'Color', scenariocolors{jj})
        hold on
        if show_fixed_values
            plot ([fixedParamValues7(jj, 1) fixedParamValues7(jj, 1)], [0 1], ...
                'Color', scenariocolors{jj}, 'Marker', scenariomarkers{jj})
        end
    end
    legend(grc, 'Location', 'SouthEast')
    hold on
    if show_fixed_values
        gen_strategy = 2;
        average_sum = mean(squeeze(piMat7(:,gen_strategy, :)))
        average_sum1 = mean(squeeze(piMat7(:,1, :)))
        plot (loadedPCol7, average_sum, '--k')
        %hold on
        % plot (loadedPCol1, average_sum1, '--b')
    end
    grid on
    ylabel(PP.y_label_param_lines, 'FontSize', PP.label_font_size)
    xlabel(PP.x_label_param_lines_hs, 'FontSize', PP.label_font_size)
    titleText = plotParameterChangeLabels{plotParam};
    ylim([ylim_min 1]);
    title(titleText,'FontSize', titleFontSize, 'FontWeight', fw)
    saveas(fig_handlePars, strcat(saveasimg, num2str(plotParam), '.eps'),'epsc');
end
%%%%%%%%%%%%%%%%%%%%% 13 %%%%%%%%%%%%%%%%%%%%%%
if (length(piMat13) > 1)
    plotParam = 13;
    
    fig_handlePars   = figure('Visible','on', 'Name', strcat('Environmental Change'));
    for jj=1:length(grc)
        plot (loadedPCol13, squeeze(piMat13(jj,strategy,:)), scenariomarkers{jj}, 'Color', scenariocolors{jj})
        hold on
    end
    legend(grc, 'Location', 'SouthEast')
    
    for jj=1:length(grc)
        
        smoothnessParam = 1.5;
        smoothedCurve = smoothn(squeeze(piMat13(jj,strategy,:)), smoothnessParam);
        plot(loadedPCol13, smoothedCurve, 'Color', scenariocolors{jj});
        hold on
        
        if show_fixed_values
            plot ([fixedParamValues13(jj, 1) fixedParamValues13(jj, 1)], [0 1], ...
                'Color', scenariocolors{jj}, 'Marker', scenariomarkers{jj})
        end
    end
    hold on
    if show_fixed_values
        gen_strategy = 2;
        average_sum = mean(squeeze(piMat13(:,gen_strategy, :)))
        average_sum1 = mean(squeeze(piMat13(:,1, :)))
        plot (loadedPCol13, average_sum, '--k')
        %hold on
        % plot (loadedPCol1, average_sum1, '--b')
    end
    grid on
    ylabel(PP.y_label_param_lines, 'FontSize', PP.label_font_size)
    xlabel(PP.x_label_param_lines_spr, 'FontSize', PP.label_font_size)
    titleText = plotParameterChangeLabels{plotParam};
    ylim([ylim_min 1]);
    title(titleText,'FontSize', titleFontSize, 'FontWeight', fw)
    saveas(fig_handlePars, strcat(saveasimg, num2str(plotParam), '.eps'),'epsc');
end

end


function plotPIsAction(PI1, PI2,PI6, plot_type, plot_gen, PP, grc, savePIas, fcnsLegend)
% PLOT PIS
K1 = 0.5;
rows = 1;
cols = 1; % later 2
fig_handlePI   = figure('Visible','on', 'Name', strcat('Performance Scenarios'));
hold on
subplot(rows,cols, 1)
PItot1=(PI1+PI2+PI6)/3;
%PItot=PItot1 ./ max(max(PItot1))
PItot = 1 - PItot1;

if plot_gen == 1
    bar33 = bar(PItot);
    mycolormap=[PP.col_(2,:);PP.col_(1,:);PP.col_(3,:)] ;
    
    fcnsLegend2 = {'Learning Strategy','Fixed Strategy'};
    legend_position = 'South';
    y_label = 'Action Performance';
    y_lim_max = 1;
else
    mycolormap=[PP.col_(1,:);PP.col_(2,:)] ;
    PItot2 = PItot(:,[1 3]);
    bar33 = bar(PItot2);
    fcnsLegend2 = {'Learning Strategy','Fixed Strategy'};
    legend_position = 'South';
    y_label = 'Action Performance';
    y_lim_max = 1;
end

colormap (fig_handlePI, mycolormap)  % Change the color scheme
set(bar33,'BarWidth', K1);
ylabel(y_label, 'FontSize', 12)
titleText1 = 'Deviation from optimal action';
set(gca,'XTick',linspace(1, length(grc), length(grc)))
%find labels
for iGrcs=1:length(grc)
    if strcmp(grc(iGrcs), 'constant')
        newgrcLabels{iGrcs} = 'Constant';
    elseif strcmp(grc(iGrcs), 'linearInc')
        newgrcLabels{iGrcs} = 'Linear Incr.';
    elseif strcmp(grc(iGrcs), 'linearDec')
        newgrcLabels{iGrcs} = 'Linear Decr.';
    elseif strcmp(grc(iGrcs), 'abIncR')
        newgrcLabels{iGrcs} = 'Abrupt Incr.';
    elseif strcmp(grc(iGrcs), 'abDecR')
        newgrcLabels{iGrcs} = 'Abrupt Decr.';
    elseif strcmp(grc(iGrcs), 'abRand')
        newgrcLabels{iGrcs} = 'Abrupt Random';
    elseif strcmp(grc(iGrcs), 'slowcos')
        newgrcLabels{iGrcs} = 'Slow Cyclic';
    elseif strcmp(grc(iGrcs), 'cos')
        newgrcLabels{iGrcs} = 'Cyclic';
    end
end

set(gca,'XTickLabel',newgrcLabels)

xticklabel_rotate([],45)
%legend(legendText)
title(titleText1,'FontSize', 16, 'FontWeight', 'b')
legend(fcnsLegend2, 'Location', legend_position)
grid on;

ylim([0 y_lim_max])

saveas(fig_handlePI, savePIas,'psc2');
hold off
clear fig_handlePI mycolormap
end

function plotPIs(PI1, PI2,PI6, plot_type, plot_gen, PP, grc, savePIas, ...
    plot_percent, PI1std, PI2std,PI6std,PI1median, PI2median,PI6median)
% PLOT PIS
K1 = 0.5;
rows = 1;
cols = 1; % later 2
fig_handlePI   = figure('Visible','on', 'Name', strcat('Performance Scenarios'));

hold on

%subplot(rows,cols, 1)
%   PItot=(PI1+PI2+PI6+PI7)/4
PItot=(PI1+PI2+PI6)/3
PItotStd=(PI1std+PI2std+PI6std)/3
PItotMedian=(PI1median+PI2median+PI6median)/3

PItot(max(size(PItot)) + 1, :) = mean (PItot);
PItotStd (max(size(PItotStd)) + 1, :) = mean (PItotStd);
PItotMedian (max(size(PItotMedian)) + 1, :) = mean (PItotMedian);

decreaseFixedPol = (PItot(:,1) - PItot(:,3)) ./ PItot(:,1); %xxx
decreaseGeneral = (PItot(:,1) - PItot(:,2)) ./ PItot(:,1);%xxx

increaseFixedPol = (PItot(:,1) - PItot(:,3)) ./ PItot(:,3);%xxx
increaseGeneral = (PItot(:,1) - PItot(:,2)) ./ PItot(:,2);%xxx

%averagerewLearnign = 1- sum(PItot(:,1))/(length(grc))
%averagerewfixed = 1- sum(PItot(:,2))/(length(grc))
y_label = 'Performance';
legend_position = 'South';
ymin_val = 0;
newgrcLabels = setGRClegendNames(grc);
newgrcLabels{1,max(size(grc)) +1} = 'Mean';
x_label_text = 'Scenario of Change';
if strcmp('plotPIsPPT_', plot_type)
    mycolormap=[PP.col_(1,:);PP.col_(2,:)] ;
    PItot2 = PItot(:,[1 3]) .* 100;
    bar33 = bar(PItot2);
    fcnsLegend2 = {'Learning Strategy','Fixed Strategy'};
    legend_position = 'SouthWest';
    y_label = 'Performance (% of optimal outcome)';
    y_lim_max = 100;
else
    if plot_gen == 1
        PItot2 = PItot(:,[1 2 3]);
        mycolormap=[PP.col_(2,:);PP.col_(1,:);PP.col_(3,:)] ;
        fcnsLegend2 = {'Specialized Learning Strategy','Robust Learning Strategy','Fixed Strategy'};
        x_label =x_label_text;
    elseif plot_gen == 0
        PItot2 = PItot(:,[1 3]);
        mycolormap=[PP.col_(1,:);PP.col_(2,:)] ;
        %PP.col2_(1,:)
        mycolormap=[PP.col2_(1,:);PP.col2_(2,:)] ;
        fcnsLegend2 = {'Learning Strategy','Fixed Strategy'};
        y_lim_max = 1.1;
        x_label = x_label_text;
        PItot2Std = PItotStd(:,[1 3]);
        PItot2Median = PItotMedian(:,[1 3]);
    elseif plot_gen == 2
        if plot_percent == 1
            PItot2 = decreaseGeneral .* 100;
            fcnsLegend2 = {'Robust strategy'};
            y_label = '% loss';
            mycolormap=[PP.col_(1,:);PP.col_(3,:)] ;
            legend_position = 'NorthEast';
            ymin_val = 0;
            y_lim_max = 4;
            x_label = x_label_text;
        else
            PItot2 = PItot(:,[1 2 ]);
            mycolormap=[PP.col_(1,:);PP.col_(3,:)] ;
            y_lim_max = 1;
            x_label = x_label_text;
        end
        %mycolormap=[PP.col_(1,:);PP.col_(3,:)] ;
        
        savePIas = strcat(savePIas)
    end
    hold on
    bar33 = bar(PItot2)
    x_std = [(1:8)-0.15; (1:8)+0.15]';
    
    errorbar(x_std, PItot2, PItot2Std, '--k')
    
    %plot (x_std, PItot2Median, 'ob')
    hold off
    
    %y_lim_max = 100;
end

% Example input:
% matrix = [1.5 1.764; 3.523 0.2];
columnLabels  = {'Specialized strategy', ...
    'Robust Strategy',...
    'Fixed Strategy'};
%rowLabels = setGRClegendNames(grc);
%rowLabels{8,1} = 'Aggregated Set';

% xxx removed for l i c reasons matrix2latex(PItot,  '../tables/PIParameters.txt',...
%    'rowLabels', newgrcLabels, 'columnLabels', columnLabels, ...
%    'size', 'small');%, ...

colormap (fig_handlePI, mycolormap)  % Change the color scheme
set(bar33,'BarWidth', K1);
ylim([ymin_val y_lim_max]);

%ylim([0 y_lim_max])
%ylabel('Reward Performance', 'FontSize', 12)

%titleText1 = 'Reward Performance per Scenario';
titleText1 = 'Reward (net income per scenario)';%'Reward Performance per Scenario';
set(gca,'XTick',linspace(1, length(newgrcLabels), length(newgrcLabels)))

set(gca,'XTickLabel',newgrcLabels, 'FontSize', PP.pi_label_font_size)
set(gca,'YTickLabel',[0:0.2:1.1], 'FontSize', PP.pi_label_font_size+1)
ylabel(y_label, 'FontSize', PP.pi_label_font_size+1)
xlabel(x_label, 'FontSize', PP.pi_label_font_size+2)
xticklabel_rotate([],45)
%legend(legendText)
%title(titleText1,'FontSize', 16, 'FontWeight', 'b')

h_legend=legend(fcnsLegend2, 'Location', legend_position)
set(h_legend,'FontSize',14);
grid on;

%ylim([0 y_lim_max])

%saveas(fig_handlePI, savePIas,'psc2'); epsc
saveas(fig_handlePI, savePIas,'epsc');
saveas(fig_handlePI, savePIas,'psc2');
hold off
clear fig_handlePI mycolormap
end
%     function bestPI(fileName)
%         filehandle=  open(fileName);
%         loadedResult   = filehandle.tmpResult;
%
%     end

% ------- CALL runAgents : make supervised plot -------------------



function [outPar, PImean, PImeanVec, fixedParamValue, PIstd, PImedian] = ...
    getPI2(fileName, param, pi_measure, start_index_pi, grcFcn)
% LOAD AGENT DATA

filehandle      = open (fileName{1});
loadedAnResult  = filehandle.anResult;
%loadedResult    = filehandle.tmpResult;
loadedResultComp= filehandle.result;
loadedParams    = filehandle.paramValues;
outPar = loadedParams(:, param);
if param == 13
    fixedparamindex = 9;
else
    fixedparamindex = param;
end
fixedParamValue = filehandle.fixedParamValues(1, fixedparamindex);
a_ana = loadedAnResult{1,7};
s_ana = loadedAnResult{1,8};
r_ana = loadedAnResult{1,9};

%[dr ss lr rbfs rbf_spread_div smtemp lambda gaer perforAIndex perforIndex useRL useET];
piVecTmp = zeros(1, 31);
PImean = zeros(1, 31);
PIstd    = 0; %zeros (1, min(size(r_ana))); % 31 data points, 50 runs
PImedian = 0;% zeros (1, min(size(r_ana)));
for ii=1:31
    a_res = loadedResultComp{ii,7};
    s_res = loadedResultComp{ii,8};
    r_res = loadedResultComp{ii,9};
    %;
    %     if ~isempty(find (e_res > 0))
    %         eee = e_res
    %     end
    
    if  strcmp(pi_measure , 'a_rel')
        piVecTmp(ii) = calculatePerformanceIndex2(a_ana, a_res, ...
            s_ana, s_res, r_ana, r_res,  'r_rel', ...
            start_index_pi, grcFcn);
    else
        piVecTmp(ii) = calculatePerformanceIndex2(a_ana, a_res, ...
            s_ana, s_res, r_ana, r_res, pi_measure, ...
            start_index_pi, grcFcn);
    end
    
    [PImean_ PIstd_ PImedian_] = calculatePerformanceIndex2(a_ana, a_res, ...
        s_ana, s_res, r_ana, r_res,  pi_measure, ...
        start_index_pi, grcFcn);
    PImeanVec   (ii) = PImean_;
    PIstdVec    (ii) = PIstd_;
    PImedianVec (ii) = PImedian_;
end
if strcmp(pi_measure , 'a_rel')
    [~, index] = max(piVecTmp);
    PImean     = PImeanVec(1, index);
else
    [~, index] = max      (PImeanVec);
    PImean   =   max      (PImeanVec);
    PIstd    =   PIstdVec    (:, index);
    PImedian =   PImedianVec (:, index);
end
end



function setGRCchange(the_grc, steps)

ECO             = E( 'logistic', 2, 0.55) ;
growthRateChangeType = the_grc;
preTrain = 50;
for ii = 1:steps
    
    ECO.P(1) = growthRateChange(1, ECO, ii, growthRateChangeType, steps, preTrain);
    growthRateChangePerGrc(1, ii)=ECO.P(1);
end
end
function newgrcLabels=setGRClegendNames(grc)
for iGrcs=1:length(grc)
    if strcmp(grc(iGrcs), 'constant')
        newgrcLabels{iGrcs} = 'Constant';
    elseif strcmp(grc(iGrcs), 'linearInc')
        newgrcLabels{iGrcs} = 'Linear Incr.';
    elseif strcmp(grc(iGrcs), 'linearDec')
        newgrcLabels{iGrcs} = 'Linear Decr.';
    elseif strcmp(grc(iGrcs), 'abIncR')
        newgrcLabels{iGrcs} = 'Abrupt Incr.';
    elseif strcmp(grc(iGrcs), 'abDecR')
        newgrcLabels{iGrcs} = 'Abrupt Decr.';
    elseif strcmp(grc(iGrcs), 'abRand')
        newgrcLabels{iGrcs} = 'Abrupt Random';
    elseif strcmp(grc(iGrcs), 'slowcos')
        newgrcLabels{iGrcs} = 'Slow Cyclic';
    elseif strcmp(grc(iGrcs), 'cos')
        newgrcLabels{iGrcs} = 'Cyclic';
    end
end
end

