function []=ProduceRobustTable()
%clear all
close all
params=  1;
nrbfs =  81;
nseeds = 50;
grc = {  'constant' 'linearInc' 'abIncR' 'cos'  'abRand' 'abDecR' 'linearDec' };
grc_opt = {  'constant' 'linearInc' 'abIncR' 'cos'  'abRand' 'abDecR' 'linearDec' 'Aggregated'};
PP=PLOTPARAMS([]);
steps = 200;
start_index_pi = 1;
savePIas = '../tables/resultsTAble.eps'; % logisticB
% -------  R E A D filenames .----------
dataFolder='Data';
pathName            = strcat('..', filesep, dataFolder, filesep);%strcat(mess.Name, filesep, 'Data', filesep);
pathNameSave        = strcat('..', filesep, '..', filesep, '..', filesep, 'latex', filesep, 'figures', filesep);

for iGrc = 1:length(grc)
    grcFcn = grc{iGrc}
    for iGrcOpt=1:length(grc_opt)
        fileName = ... %strcat(num2str(nrbfs),'LData_NR_31_NS_200_Seeds_25_p_');
            strcat(num2str(nrbfs),'LData_NR_1_NS_200_Seeds_',...
            num2str(nseeds), '_p_', grc_opt{iGrcOpt})
        % pi_measure = cell(1, length(grc), length(grc));
        % result_file_name = char(zeros(length(grc), length(grc)));
        
        pathNameF       = strcat(pathName, 'unsupervisedlogistic', filesep, grcFcn, filesep);
        
        %pathNameSaveF   = strcat('unsupervisedlogistic');
        
        pi_measure = 'r_rel';
        
        pi(iGrc, iGrcOpt) = getPI2(strcat(pathNameF, fileName, '.mat'), pi_measure, start_index_pi, grcFcn);
        if iGrc == iGrcOpt
            % when running the scenario with its own optimized parameters
            pi_self(iGrc,:) = pi(iGrc, iGrcOpt);
        end
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PI
pi(length(grc) + 1, :) = mean(pi,1)
pi(:,length(grc_opt)+1) = mean(pi,2)
abbrev_heading_style = 1;
columnLabels  = setGRClegendNames(grc_opt, 1, abbrev_heading_style);
columnLabels {1,9} = 'Mean';
abbrev_heading_style = 1;
rowLabels = setGRClegendNames(grc, 0, abbrev_heading_style); %setGRClegendNames(grc);
rowLabels{1,8} = 'Mean';

% % removed for l i c reasons matrix2latex(pi,  '../tables/PITable.txt',...
%    'rowLabels', rowLabels, 'columnLabels', columnLabels, ...
%    'size', 'footnotesize');%, ...

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PI percent
pi_ = pi(1:7,1:8);
%pi_self(:,1) = %max(pi_,[],2)

pi_perc = (repmat(pi_self, 1, 8) - pi_) ./ repmat(pi_self, 1, 8)
% add mean and max
pi_perc_mm(:,:) = pi_perc(:,:)
[rows cols] = size(pi_perc)

pi_perc_mm(8,:) = sum(pi_perc,1) / (rows - 1)
pi_perc_mm(9,:) = max(pi_perc,[],1)

clear columnLabels rowLabels
abbrev_heading_style = 1;
columnLabels  = setGRClegendNames(grc_opt, 1, abbrev_heading_style);
abbrev_heading_style = 2;
rowLabels = setGRClegendNames(grc, 0, abbrev_heading_style); %setGRClegendNames(grc);
rowLabels{8}='Mean';
rowLabels{9}='Max';
pi_perc2=( (pi_perc_mm)) .*100
% removed for l i c reasons  matrix2latex(pi_perc2,  '../tables/PITablePercTot.txt',...
%    'rowLabels', rowLabels, 'columnLabels', columnLabels, ...
%    'size', 'footnotesize', 'format', '%0.3f', 'alignment', 'r');%, ...

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PI percent final, 2 columns only
[rows cols] = size(pi_perc)
pi_perc_fin(:,1) = sum(pi_perc,1) / (rows - 1)
pi_perc_fin(:,2) = max(pi_perc,[],1)
%pi_perc_fin(8,)
clear  columnLabels rowLabels
columnLabels  = {'Mean Loss', 'Max Loss'};
abbrev_heading_style = 2;
rowLabels = setGRClegendNames(grc, 1, abbrev_heading_style); %setGRClegendNames(grc);
rowLabels{1,8} = strcat('Opt[Aggreg. set]');
pi_perc_fin2 = (round (pi_perc_fin .* 10000)) ./100


% sort according to max
[x index ] = sort(pi_perc_fin2(:,2), 1)
pi_perc_fin2_sorted = pi_perc_fin2(index,:)
rowLabels_sorted = rowLabels (index)
% % removed for l i c reasons matrix2latex(pi_perc_fin2_sorted,  '../tables/PITablePerc_max.txt',...
%    'rowLabels', rowLabels_sorted, 'columnLabels', columnLabels, ...
%    'size', 'footnotesize', 'format', '%0.2f', 'alignment', 'r');%, ...

clear x index pi_perc_fin2_sorted  rowLabels_sorted
% sort according to max
[x index ] = sort(pi_perc_fin2(:,1), 1)
pi_perc_fin2_sorted = pi_perc_fin2(index,:)
rowLabels_sorted = rowLabels (index)
% removed for l i c reasons  matrix2latex(pi_perc_fin2_sorted,  '../tables/PITablePerc_mean.txt',...
%    'rowLabels', rowLabels_sorted, 'columnLabels', columnLabels, ...
%    'size', 'footnotesize', 'format', '%0.2f', 'alignment', 'r');%, ...

end
function [PI] = ...
    getPI2(fileName, pi_measure, start_index_pi, grcFcn)
% LOAD AGENT DATA

filehandle      = open (fileName);
loadedAnResult  = filehandle.anResult;
%loadedResult    = filehandle.tmpResult;
loadedResultComp= filehandle.result;
loadedParams    = filehandle.paramValues;

temp=loadedParams(1,6)
a_ana = loadedAnResult{1,7};
s_ana = loadedAnResult{1,8};
r_ana = loadedAnResult{1,9};

%[dr ss lr rbfs rbf_spread_div smtemp lambda gaer perforAIndex perforIndex useRL useET];


a_res = loadedResultComp{1,7};
s_res = loadedResultComp{1,8};
r_res = loadedResultComp{1,9};

PI = calculatePerformanceIndex2(a_ana, a_res, ...
    s_ana, s_res, r_ana, r_res,  pi_measure, ...
    start_index_pi, grcFcn);
end

function newgrcLabels=setGRClegendNames(grc, opt, abbreviation_type)
if abbreviation_type == 1 % short
    for iGrcs=1:length(grc)
        if strcmp(grc(iGrcs), 'constant')
            newgrcLabels{iGrcs} = 'Cnst.';
        elseif strcmp(grc(iGrcs), 'linearInc')
            newgrcLabels{iGrcs} = 'Lin I';
        elseif strcmp(grc(iGrcs), 'linearDec')
            newgrcLabels{iGrcs} = 'Lin D';
        elseif strcmp(grc(iGrcs), 'abIncR')
            newgrcLabels{iGrcs} = 'Ab I';
        elseif strcmp(grc(iGrcs), 'abDecR')
            newgrcLabels{iGrcs} = 'Ab D';
        elseif strcmp(grc(iGrcs), 'abRand')
            newgrcLabels{iGrcs} = 'Ab R';
        elseif strcmp(grc(iGrcs), 'slowcos')
            newgrcLabels{iGrcs} = 'Slow Cyclic';
        elseif strcmp(grc(iGrcs), 'cos')
            newgrcLabels{iGrcs} = 'Cyc';
        elseif strcmp(grc(iGrcs), 'Aggregated')
            newgrcLabels{iGrcs} = 'Ag';
        end
    end
else abbreviation_type == 2 % longer
    for iGrcs=1:length(grc)
        if strcmp(grc(iGrcs), 'constant')
            newgrcLabels{iGrcs} = 'Const.';
        elseif strcmp(grc(iGrcs), 'linearInc')
            newgrcLabels{iGrcs} = 'Lin I.';
        elseif strcmp(grc(iGrcs), 'linearDec')
            newgrcLabels{iGrcs} = 'Lin D.';
        elseif strcmp(grc(iGrcs), 'abIncR')
            newgrcLabels{iGrcs} = 'Abrupt I.';
        elseif strcmp(grc(iGrcs), 'abDecR')
            newgrcLabels{iGrcs} = 'Abrupt D.';
        elseif strcmp(grc(iGrcs), 'abRand')
            newgrcLabels{iGrcs} = 'Abrupt R.';
        elseif strcmp(grc(iGrcs), 'slowcos')
            newgrcLabels{iGrcs} = 'Slow Cyclic';
        elseif strcmp(grc(iGrcs), 'cos')
            newgrcLabels{iGrcs} = 'Cyclic';
        elseif strcmp(grc(iGrcs), 'Aggregated')
            newgrcLabels{iGrcs} = 'Aggr';
        end
        
    end
end

if opt == 1
    newgrcLabels=strcat('Opt[',newgrcLabels, ']')
end
end



