function [A] = createAgents(varargin)
import agentx.*;

if (length(varargin) >= 1)
    IP = varargin{1};
else
    disp('error_in_create_agents_first_arg_must_be_IP_struct')
end

if (length(varargin) >= 2)
    ECO = varargin{2};
else
    disp('error_in_create_agents_second_arg_must_be_ECO_struct')
end

if (length(varargin) >= 3)
    f = varargin{3};
else
    f = '';
    % disp('error_in_create_agents_second_arg_must_be_ECO_struct')
end

% if only reset RL
if (length(varargin) >= 4)
    the_nn = varargin{4};
else
    the_nn = 0;
    % disp('error_in_create_agents_second_arg_must_be_ECO_struct')
end


if (length(varargin) >= 5)
    startActions = varargin{5};
else
    startActions = 0;
    % disp('error_in_create_agents_second_arg_must_be_ECO_struct')
end


    % MATLAB AGENTS
if strcmp(IP.agentType, 'matlab')


    inputSpan=ECO.AgentInputRanges;
    
    %inputSpan=[0 10; 0 10];
    
    load('AgentParms.mat','S');    %or load a struct,
   % S.learningRate=0.5;            %adjust values
    %S.numRbfs=36;
    A=Agent(S);                  %and initiate with the struct
    
   % A.Face.setAgent(S);            %You can also set everything after the agent is created
    
    %agentFileName = 'NewAgent.mat';
    %A.face.saveAgent(agentFileName); %save agent for later use
    
    %You may want to rapidly change the main parameters
    learningRate    = IP.lr;
    discountRate    = IP.dr; 
    stepSize        = IP.ss;
    lambda          = IP.lambda;
    temperature     = IP.SMtemp; 
    spread          = IP.RBFsSpread;
    numRbfs         = IP.rbfs;
    useRL           = IP.useRL;
    useET           = IP.useEligabilityTraces;
    
    for i=1:IP.numAgents
        A(i) = Agent(S);                  %and initiate with the struct
        A(i).setFaceParams(learningRate,discountRate, stepSize,lambda,temperature, spread,numRbfs, useRL, useET);
        A(i).setUseSprimByAgent(IP.useSprimByAgent);
        A(i).setStartActions(startActions);
        %A(i).face.who
        %S=A.face.getS
    end
end
end


