%calculates the change in growthrate according to a certain type of change
function gr=growthRateChange(varargin)

pc          = varargin {1}; % change this parameter in the ECOSYSTEM
ECO         = varargin {2};
i           = varargin {3}; % current timestep
type        = varargin {4}; % grc
steps       = varargin {5};  % total num steps
preTrain    = varargin {6}; % train before change starts
gr          = ECO.P(pc);
grStartup   = ECO.P(8); % 1.0

abChangeInterval        = 25;
%repeatIntervalabRand    = 300;
%repeatIntervalabIncDec  = 50; %was 150
repeatIntervalabIncDecR = 76;
repeatIntervalCos       = 50;
repeatIntervalSlowCos   = 150;
fcnType = ECO.M;

if i > preTrain
    i = i - preTrain;
    if strcmp(fcnType, 'logistic')
        
        linearGrowthInc = linspace(grStartup, grStartup + 0.8, steps-preTrain);
        linearGrowthDec = linspace(grStartup, grStartup - 0.8, steps-preTrain);
        mv=1;
    elseif strcmp(fcnType, 'hysteresis')
        linearGrowthInc = linspace(grStartup-0.1, grStartup + 0.5, steps-preTrain); % 1.6 in simulateParallelRemote
        linearGrowthDec = linspace(grStartup-0.1, grStartup - 0.6, steps-preTrain); % 1.6 in simulateParallelRemote
        mv=1.8;
    elseif strcmp(fcnType, 'hysteresis1')
        linearGrowthInc = linspace(grStartup,  grStartup + 0.6, steps-preTrain); % 1.6 in simulateParallelRemote
        linearGrowthDec = linspace(grStartup, grStartup - 0.6, steps-preTrain); % 1.6 in simulateParallelRemote
        mv=3;
    elseif strcmp(fcnType, 'hysteresis2')
        linearGrowthInc = linspace(grStartup,   grStartup + 0.6, steps-preTrain); % 1.6 in simulateParallelRemote
        linearGrowthDec = linspace(grStartup, grStartup - 0.6, steps-preTrain); % 1.6 in simulateParallelRemote
        mv=3;
    end
    
    
    
    % --- RANDOM ---
    
    if strcmp(type, 'abRand')
        if i==1
            
            gr = grStartup;
            gr = gr - 0.8;
            if strcmp(fcnType, 'hysteresis')
                gr = gr - 0.05;
            end
        elseif i == (abChangeInterval + 1)
            
            gr = ECO.P(pc) + 0.5;
            % gr = gr*changeconstant;
        elseif i == (abChangeInterval*2 + 1)
            
          gr = ECO.P(pc) + 0.9;
         
            %gr = gr*changeconstant;
        elseif i == (abChangeInterval*3+ 1)
            
            gr = ECO.P(pc) - 1.2;
            %gr = gr*changeconstant;
        elseif i == (abChangeInterval*4+ 1)
            
            gr = ECO.P(pc) + 0.9;
            %gr = gr*changeconstant;
        elseif i == (abChangeInterval*5+ 1)
            
            gr = ECO.P(pc) + 0.5;
            %gr = gr*changeconstant;
 %       elseif i == abChangeInterval*6
%            gr = ECO.P(pc) + 0.3;
            %gr = gr*changeconstant;
%         elseif i == abChangeInterval*7
%             gr = ECO.P(pc) - 0.6;
%             %gr = gr*changeconstant;
%         elseif i == abChangeInterval*8
%             gr = ECO.P(pc) + 0.3;
%             %gr = gr*changeconstant;
%         elseif i == abChangeInterval*9
%             gr = ECO.P(pc) - 0.3;
%             %gr = gr*changeconstant;
%         elseif i == abChangeInterval*10
%             gr = ECO.P(pc) + 0.6;
%             %gr = gr*changeconstant;
%         elseif i == abChangeInterval*11
%             gr = ECO.P(pc) + 0.9;
%             %gr = gr*changeconstant;
        end
    end
    
    %HIGHER
    if strcmp(type, 'abIncR')
        if i==1
            gr = grStartup;
            gr = gr + 0.4;
            if strcmp(fcnType, 'hysteresis')
                %gr = gr - 0.1;
                gr = gr - 0.1;
            end
        elseif i == repeatIntervalabIncDecR
            gr = ECO.P(pc) + 0.4;
            % gr = gr*0.8486;
        elseif i == repeatIntervalabIncDecR*2 
            gr = ECO.P(pc) + 0.4;
            %gr = gr*0.8486;
        end
    end
    
    if strcmp(type, 'abDecR')
        if i==1
            gr = grStartup;
            gr = gr - 0.4;
            if strcmp(fcnType, 'hysteresis')
                gr = gr - 0.05;
            end
        elseif i ==  repeatIntervalabIncDecR
            gr = ECO.P(pc) - 0.4;
        elseif i == repeatIntervalabIncDecR*2 
            gr = ECO.P(pc) - 0.4;
        end
    end
    
    
    % --- LINEAR INCREASING
    if strcmp(type, 'linearInc')
        increment = 0.8/150;%xxx
        gr = gr +increment ;%linearGrowthInc (i);
    end
    
    % --- LINEAR DECCREASING
    if strcmp(type, 'linearDec')
       increment = 0.8/150; %xxx
        gr = gr-increment; %xxx
    end
    
    % --- COSINUS
    if strcmp(type, 'cos')
        
        if strcmp(fcnType, 'logistic')
            %             mv=0.3; %moves and trycker ihop kurvan
            %             smashCurve = 1.0; %moveas and trycker ihop kurvan
            %             moveVertically = mv; %f?rskjutning h?jdled
            %             moveHorizontally = 38;%f?rskjutning sidled
            %             gr = ((cos((i+moveHorizontally)/repeatIntervalCos*2*pi())+smashCurve)+moveVertically)./1.3;
            %
            
            period = 50;
            omega = 2 * pi / period;
            gr =  0.8 * sin ( omega * i ) + 1;
            
        elseif strcmp(fcnType, 'hysteresis')
            smashCurve = 1; %trycker ihop kurvan
            moveVertically=mv; %f?rskjutning h?jdled
            moveHorizontally = 38;%22.5;%f?rskjutning sidled
            gr = ((cos((i+moveHorizontally)/repeatIntervalCos*2*pi())+smashCurve)+moveVertically)./2;
        end
    end
    
    if strcmp(type, 'slowcos')
        if strcmp(fcnType, 'logistic')
            smashCurve = 1; %trycker ihop kurvan
            moveVertically=0.3; %f?rskjutning h?jdled
            moveHorizontally = 37;%f?rskjutning sidled
            gr=((cos((i+moveHorizontally)/repeatIntervalSlowCos*2*pi())+smashCurve)+moveVertically)./1.3;
            
        elseif strcmp(fcnType, 'hysteresis')
            smashCurve = 1; %trycker ihop kurvan
            moveVertically=mv; %f?rskjutning h?jdled
            moveHorizontally = 35;%f?rskjutning sidled
            gr=((cos((i+moveHorizontally)/repeatIntervalSlowCos*2*pi())+smashCurve)+moveVertically)./2;
        end
    end
    % --- CONSTANT
    if strcmp(type, 'constant')
        %do nothing
        gr=ECO.P(pc);
    end
end