%Called by startSimulation
function out=runAgentsGrc(varargin)
import agentx.*;
IP                  = INIT(varargin{1}); % init parameters
fcnName={IP.ecoFcn};

simulateRemote = false;
if simulateRemote
elseif ~IP.calcAnSolution
    %h = figure('Visible','on');
    % set(h,'DefaultAxesColorOrder', ...
    %     [1 0 0;  0 1 0;  0 0 1;  1 1 0; 0 1 1;    ...
    %     0.9 0 0;0 0.9 0;0 0 0.9;0.9 0.9 0; 0 0.9 0.9],...
    %     'DefaultAxesLineStyleOrder','-|-|-|-|-|--|--|--|--|--', ...
    %     'Name', IP.chapterName);
    %set(h,'Name', IP.chapterName);
end
if IP.plotMMforPaper == 1
    h = figure('Visible','on');
end
%set(h,'Name', IP.chapterName);
addH=0;
error='';

N = 50;
H = linspace(0,1,N);
[X,Y] = meshgrid(H,H); % 10=ECO.P(2)
AC = reshape(X,1,N*N);
ST = reshape(Y,1,N*N);
performanceIndexMatrix = zeros(length(IP.lambda), length(IP.growthChangeTypes));
numAgents = IP.numAgents;
iRepeat=0;
stopRun=false;
preTrain = 50;
PP = PLOTPARAMS([]);

if strcmp(fcnName, 'logistic')
    optLogFile=open('OptConLog.mat');
    ocfileA = optLogFile.closestTo5A;
    ocfileS = optLogFile.the_states;
    
elseif strcmp(fcnName, 'hysteresis') || strcmp(fcnName, 'hysteresis1') ||  strcmp(fcnName, 'hysteresis2')
    optHystFile=open('OptConHyst.mat');
    ocfileA = optHystFile.closestTo5A;
    ocfileS = optHystFile.the_states;
end

for pis=1:length(IP.growthChangeTypes)
    
     growthRateChangeType = IP.growthChangeTypes{pis};
    % imgName = ['growthRateChangeType' growthRateChangeType '_' num2str(IP.steps) 'steps_' ...
    % num2str(IP.numSeedTries) 'replicates_' IP.agentType 'Agent' '.tiff'];%'Higher5runMatlabAgent.tiff';
    % disp(['growthRateChangeType: ' growthRateChangeType]);
    for f=1:length(fcnName)
        seedCtr = 0;
        for k=1:IP.numSeedTries % e.g 5 drop series
            % use same vector of state drops for eg 10 runs so we get a
            % fair judgement of the agents performance
            % agents actions have different randoms each of the 10 runs.
            if IP.cutTrace == true
                drops(1) = 0;drops(2) = 0;drops(3) = 0;
                for i = 4 : IP.steps
                    randtest = rand();
                    randnr = rand();
                    if randtest >= 0.95 
                        drops(i) = 0.05 + randnr * 0.9;
                    else
                        drops(i) = 0;
                    end
                end
            end
            
            for m=1:length(IP.startStates)
                startState = IP.startStates(m);
                
                for n=1:size(IP.startActions,1)
                    startActions = IP.startActions(n,:);
                    
                    
                    for l=1:IP.runsPerDropSeries % e.g. runs per action state start values
                        
                        %disp(['run nr: ' num2str(k) ' of ' num2str(IP.numSeedTries) ' start state ' num2str(m) ' of ' num2str(length(stateValues))]);
                        clear A actionMatrix ucMatrix ucMatrixClassic statesMatrix rewardMatrix performanceIndex
                        ECO             = E( fcnName(f), IP.numInputs, startState) ;
                        
                        % first time
                        %if m == 1
                        the_nn = 0;
                        %elseif m > 1
                        %   the_nn = savedNN;
                        %end
                        % save mental model
                        % savedNN = A(1, :).getNN();
                        
                        A(1, :) = createAgents(IP, ECO, fcnName(f), the_nn, startActions);
                        

                        for j=1:numAgents
                            % tci = 1;
                            seedCtr=seedCtr + 1;
                            growthRateStartup=ECO.P(1);

                            
                            % fix for repeating growth rate change scenarios
                            repInterval = 0;
                            if strcmp(growthRateChangeType, 'abRand')
                                repInterval = IP.repeatIntervalabRand;
                            elseif strcmp(growthRateChangeType, 'abDec') || strcmp(growthRateChangeType, 'abInc')
                                repInterval = IP.repeatIntervalabIncDec;
                            elseif strcmp(growthRateChangeType, 'abDecR') || strcmp(growthRateChangeType, 'abIncR')
                                repInterval = IP.repeatIntervalabIncDecR;
                            elseif strcmp(growthRateChangeType, 'cos')
                               % repInterval = IP.repeatIntervalCos;
                            elseif strcmp(growthRateChangeType, 'slowcos')
                                %repInterval = IP.repeatIntervalSlowCos;
                                
                            end
                            iRepeat=0;
                            
                            for i = 1:IP.steps
                                
                 
                                    iRepeat = iRepeat + 1;
                     
                                
                                ECO.P(IP.MP) = growthRateChange(1, ECO, iRepeat, growthRateChangeType, IP.steps, preTrain);
                                
                                noice = ((rand-0.5) * IP.noice);
                      
                                cutTrace = false;
                                if IP.cutTrace == true && strcmp(IP.learningType, 'unsupervised')
                                    if drops(i) > 0
                                        ECO.S = ECO.S * drops(i);
                                        cutTrace = true;
                                    end
                                end
                               
                                states(i) = ECO.S;
                               
                                % analythical agent
                                if IP.calcAnSolution
                                    
                                    if strcmp(IP.ecoFcn, 'logistic')
                                        
                                        K = ECO.P(2);
                                        g = ECO.P(1); 
                                       
                                    % fixed cost at 0.1    action(i) = max(0, 1 + g*(1-states(i)/K) - (K+0.1)/(2*states(i)));
                                        action(i) = min(max (0, ((1+g*(1-states(i)/K) - K/(states(i)*2))/(0.1/(2*states(i)) + 1))), 1); % analytical
                                        aOpt(i) = action(i);
                                        
                                    elseif strcmp(IP.ecoFcn, 'hysteresis') || strcmp(IP.ecoFcn, 'hysteresis1') ||  strcmp(IP.ecoFcn, 'hysteresis2')
                                        g = ECO.P(1);
                                        K = ECO.P(2);
                                        
                                        action(i) = min(1, max(0, 1 + g*(1-states(i)/K) ...
                                            - ECO.P(5)*states(1,i)/(ECO.P(4).^2+states(1,i).^2) ...
                                            - (K+0.1)/(2*states(i))));
                                        %max(0,((states(i) + g*(1-states(i)/K)*states(i) + I - Sstar) / ...
                                        %   (states(i)^2/(h^2+states(i)^2)))/corr) ;
                                        aOpt(i)=action(i);
                                    else
                                        disp('error wrong eco fcn')
                                    end
                                    eLevel(i) = 0;

                                elseif strcmp(IP.learningType, 'unsupervised')
                                    if IP.numInputs == 2
                                        if i > 1
                                          statePred(i) = A(1, j).calcSprimAgent(action(i-1), states(i-1));
                                         else
                                            statePred(i) = states(i);
                                         end
                                        %%%%%%%%%%%%%%%%%%%%%%% hazard !!!!        %%%% - - - - - - - %%%
                                       % g = ECO.P(1); % HAZARD REMOVE
                                        %K = ECO.P(2); % HAZARD REMOVE
                                       % action(i) = 0.45;%max(0, 1 + g*(1-states(i)/K)-(K+0.1)/(2*states(i))); % HAZARD REMOVE
                                         action(i)=A(1,j).getPolicy(statePred(i) + noice);
                                        %action(i)=0.45;
                                        eLevel(i)  = A(1, j).getExperimentationSoftmaxVSGreedy();
                                        
                                    elseif IP.numInputs == 3
                                        disp('needs correction runAgent')
                                        action(i)   = A(1, j).getPolicy([states(i) + noice; ECO.P(1)]);
                                    end
                                end 
                                
                                % 3. Observe the reward
                                if IP.calcAnSolution
                                    reward(i) = action(i) * states(i) - action(i)*0.1;
                                    
                                elseif strcmp(IP.learningType, 'unsupervised')
                                    reward(i) = action(i) * states(i) - action(i)*0.1;
                                elseif strcmp(IP.learningType, 'supervised')
                                    rewardOC(i) = exp(-(abs(action(i)-aOpt(i))));%exp(-((action(i)-aOpt(i))^2));
                                    reward(i) = aOpt(i) * states(i) - aOpt(i)*0.1;
                                end
                                
                                % 4. Train the agents with the action chosen from state & old reward
                                
                                
                                if ~IP.calcAnSolution
                                    if strcmp(IP.learningType, 'supervised')
                                        stopRun=A(1, j).trainCT([action(i); states(i)], rewardOC(i), cutTrace, IP.trainWcutTrace);
                                        
                                    elseif IP.findOptimalParams
                                        if abs(states(i) - ECO.P(6)) > 0.0001
                                            diffOC=abs((ocfileS - states(i)));
                                            [~, indexS] = sort(diffOC, 'ascend');
                                            OCA(i)= ocfileA(indexS(1));
                                            MSEOC(i) = exp(-(abs(action(i)-OCA(i))));%(abs(action(i) - OCA(i)))/OCA(i); % add one to avoid going toward zero
                                        else
                                            MSEOC(i) = 1;
                                        end
                                        stopRun=A(1, j).trainCT([action(i); states(i)], MSEOC(i), cutTrace, IP.trainWcutTrace);
                                        
                                    elseif strcmp(IP.learningType, 'unsupervised')
                                        
                                        stopRun=A(1, j).trainCT([action(i); states(i)+noice], reward(i), cutTrace, IP.trainWcutTrace);
                                        %disp('Testing learning model')
                                        %omega_ = A(1, j).getOmega()
                                        
                                        %                                 evec = A(1,j).getExperiencesVector;
                                        %                                 eLen=size(evec, 2)-2;
                                        %                                 if eLen > 1
                                        %                                     subplot(2,1,1)
                                        %                                     plot(evec(6,1:eLen), evec(1:3,1:eLen))
                                        %                                     legend( 'a', 's', 'r')
                                        %                                     hold on
                                        %                                     grid on
                                        %                                     if cutTrace
                                        %                                         plot(i, 0, 'ob')
                                        %                                     end
                                        %                                     eVal = evec(5,1:eLen);
                                        %                                     subplot(2,1,2)
                                        %                                     plot(evec(6,1:eLen), eVal,'.-c')
                                        %                                     legend('Qacc')
                                        %                                     hold off
                                        %                                     grid on
                                        %                                      if cutTrace
                                        %                                         plot(i, 0, 'ob')
                                        %                                         hold on
                                        %                                     end
                                        %                                     drawnow
                                        %                                     pause(0.1)
                                        %                                 end
                                        
                                    else
                                        stopRun=A(1, j).trainCT([action(i); states(i)], reward(i), cutTrace,IP.trainWcutTrace);
                                        disp('cant happen? ')
                                    end
                                    %disp('train')
                                    if stopRun
                                        break;
                                    end
                                end
                                
                                % 2. Update the ecosystem (perform the action in the
                                % environment)
                                if strcmp(IP.learningType, 'unsupervised') || IP.calcAnSolution
                                    ECO         = E(ECO, action(i), states (i), 1);
                                end
                                
                                % PLOTTA VARJE TIDSSTEG -------------------------
                                if j == 1 && f == 1 && ~IP.calcAnSolution
                                    % plotMMForPaper(AC, ST, A,N, X, Y, fcnName,f, h, IP, PP)
                                    
                                    %plotMM(AC, ST, A,N, X,Y,fcnName,f, action(i), states(i))
                                    
                                    
                                end
                            end % end steps
                            
                            %if ~IP.calcAnSolution
                            %   evec = A(1,j).getExperiencesVector;
                            
                            %end
                            
                            
                            
                            % CHECK UP  if the weights are converging
                            %                     sumLW(m) = sum(A(1, :).getNNLW());
                            %                     if mod(m,20) == 0
                            %                         m
                            %                         m1=m-19;
                            %                         m2=m-10;
                            %                         lwAve1 = sum(sumLW(m1:m2));
                            %                         lwAve2 = sum(sumLW(m-9:m));
                            %                         difflw = (lwAve1 - lwAve2)
                            %                     end
                            % fix for not using unfinished runs in analysis
                           if stopRun
                                action=zeros(1,IP.steps);
                                states=zeros(1,IP.steps);
                                reward=zeros(1,IP.steps);
                                eLevel=zeros(1,IP.steps);
                            end
                            
                            actionMatrix (j, :) = action(:, IP.plotSteps+1:IP.steps);
                            statesMatrix (j, :) = states(:, IP.plotSteps+1:IP.steps);
                            rewardMatrix (j, :) = reward(:, IP.plotSteps+1:IP.steps);
                            eLevelMatrix (j, :) = eLevel(:, IP.plotSteps+1:IP.steps);
                            agentMatrix  (j, :) = A;
                            % saving sum for staples standard avvikelse, discount 150
                            % first steps
                            
                            clear action ECO states reward eLevel
                            % reset the ecosystem for the next agent to use
                            ECO = E( fcnName(f), IP.numInputs, startState);
                            
                        end % end num agents
                        
                        if IP.calcAnSolution
                            theOptPath = ocfileA;%calcAnOptPath(IP.testStates, fcnName, ECO);
                        else
                            theOptPath = calcOptPath(A(1,:), IP.testStates);
                        end
                      aM(seedCtr,:)         = actionMatrix;
                        sM(seedCtr,:)         = statesMatrix;
                        rM(seedCtr,:)         = rewardMatrix;
                        eM(seedCtr,:)         = eLevelMatrix;

                        oM(seedCtr,:)         = theOptPath;
                        agM(seedCtr,:)        = agentMatrix;

                        if seedCtr==1
                            %if ~IP.calcAnSolution
                            %   evecM = evec;
                            %end
                            averageAMatrix  = actionMatrix;
                            averageSMatrix  = statesMatrix;
                            averageRMatrix  = rewardMatrix;
                            averageOptPath  = theOptPath;
                            averageEMatrix  = eLevelMatrix;
                        else
                            % if ~IP.calcAnSolution
                            %    evecM = evecM + evec;
                            %end
                            averageAMatrix  = averageAMatrix  + actionMatrix;
                            averageSMatrix  = averageSMatrix  + statesMatrix;
                            averageRMatrix  = averageRMatrix  + rewardMatrix;
                            averageOptPath  = averageOptPath  + theOptPath;
                            averageEMatrix  = averageEMatrix  + eLevelMatrix;

                            
                        end
                        % PLOT FOR EACH SET OF STEPS ------------------------------
                        if ~IP.calcAnSolution
                            %plotASRMMBest(IP,actionMatrix,statesMatrix, rewardMatrix, AC, ST, A,N, X, Y, fcnName,f, startState, ECO, IP.testStates, startActions)
                        end
                    end %action values
                end % end state vlues
            end
        end % end k numSEeds
        %if ~IP.calcAnSolution
        %   evecM  = evecM./IP.numSeedTries;
        %end
            averageAMatrix  = averageAMatrix./seedCtr;
        averageSMatrix  = averageSMatrix./seedCtr;
        averageRMatrix  = averageRMatrix./seedCtr;
        averageOptPath  = averageOptPath./seedCtr;
        averageEMatrix  = averageEMatrix./seedCtr;

        out={averageAMatrix averageSMatrix averageRMatrix averageOptPath averageEMatrix eM aM sM rM oM agM};
        
        % PLOT THE EFFECTS OF ELIGIBILITY TRACES
        %         if ~IP.calcAnSolution
        %
        %             eLen = size(evecM, 2);
        %             if eLen > 1
        %                 subplot(3,1,1)
        %                 plot(evecM(6,1:eLen), evecM(1:3,1:eLen))
        %                 legend( 'a', 's', 'r')
        %                 grid on
        %                 hold on
        %
        %                 subplot(3,1,2)
        %                 eVal = evecM(5,1:eLen);
        %                 plot(evecM(6,1:eLen), eVal,'.-g')
        %                 hold on
        %                 %traceCutIndex
        %                 plot(traceCutIndex, 0, 'ok')
        %                 legend('Qacc')
        %                 hold on
        %
        %                 grid on
        %                 subplot(3,1,3)
        %
        %                 x=min(min(evecM(5,1:eLen)));
        %                 if x > 0
        %                     dotcolor=(evecM(5,1:eLen)+abs(x))./(max(evecM(5,:)+abs(x)));
        %                     % max diff = 100, om diff = 99 n?ra max diff f?r f?rg vit
        %                     % om diff = 1 f?r f?rg svart
        %                     % mycket acc-diff f?r vit f?rg
        %                     % lite acc-diff f?r svart f?rg
        %
        %                     for i=1:size(dotcolor, 2)
        %                         %if dotcolor(i) < 0.8
        %                         color_=[dotcolor(i) dotcolor(i) dotcolor(i) ];
        %                         plot(evecM(1,i), evecM(2,i), '.', 'Color', color_)
        %                         grid on
        %                         hold on
        %                         %end
        %                     end
        %                     legend( 'a s pairs')
        %                 end
        %                 %performance:
        %                rew = sum(evecM(3,1:eLen))
        %
        %             end
        %         end
        
        % PLOT FINAL RESULT FOR A ECOFCN ------------------------------
        if f == 1 && i >= IP.plotSteps
            %plotASRMMBest(IP,averageAMatrix,averageSMatrix, averageRMatrix, AC, ST, A,N, X, Y, fcnName,f, startState, ECO, IP.testStates, startActions)
            if IP.plotMMforPaper == 1 && ~IP.calcAnSolution
                
                
                plotMMForPaper(AC, ST, A,N, X, Y, fcnName,f, h, IP, PP, ocfileA)
            end
        end
        clear averageAMatrix averageSMatrix averageRMatrix averageUCMatrix averageOptPath
    end
end
end

% calculate how the agents optimal path/control looks
function out=calcOptPath(A, testStates)
for q=1:length(testStates)
    out(q)          = A(1,1).getBestAction(testStates(q));
end
%out=MMactions;
end

%  - - - - - PLOT MENTAL MODELS ---------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%    PAPER MENTAL MODEL PLOT %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function []=plotMMForPaper(AC, ST, A,N, X, Y, fcnName,f, h, IP, PP, ocfileA)

for q=1:length(AC)
    MM(q)          = A(1,1).sim([AC(q); ST(q)]);
end
MM      = reshape(MM, N, N);
%meshc(X,Y,MM);
%pcolor(X,Y,MM);shading flat

optPathAgent=calcOptPath(A, IP.testStates);

optPathAnalythical  = ocfileA;%IP.anaResult{4};
plot(linspace(0,1,151), optPathAgent, 'w*')
hold on
plot(linspace(0,1, length(optPathAnalythical)),optPathAnalythical, 'w-')

legend_handle=legend(PP.OCagent, PP.OC, 'Location', 'SouthEast');
set(legend_handle, 'Color', PP.colLightGrey, 'FontSize', PP.fontSizeSmall)

hold on

pcolor(Y,X,MM);%./repmat(max(MM,[],1),50,1));
shading flat; colorbar;
plot(linspace(0,1,151), optPathAgent, 'w*')
plot(linspace(0,1, length(optPathAnalythical)),optPathAnalythical, 'w-', 'Linewidth', 2)

xlabel ('State', 'FontSize', PP.fontSizeNormal)
ylabel ('Action', 'FontSize', PP.fontSizeNormal)

if strcmp(IP.learningType, 'supervised')
    title(['Mental Model (Supervised Learning) '], 'FontSize', PP.fontSizeNormal)
    saveFigName     = '../../../latex/figures/NNsup.eps';
    saveas(h, saveFigName,'psc2');
    saveFigName     = char(strcat('../../../latex/figures/NNsup',fcnName{f},'.eps'));
    saveas(h, saveFigName,'psc2');
    
elseif strcmp(IP.learningType, 'unsupervised') && IP.useRL == 0
    title(['Mental Model (Unsupervised No RL) ' ], 'FontSize', PP.fontSizeNormal)
    saveFigName     = '../../../latex/figures/NNunsup.eps';
    saveas(h, saveFigName,'psc2');
    
elseif strcmp(IP.learningType, 'unsupervised') && IP.useRL == 1
    title(['Mental Model (unsupervised With RL) ' ], 'FontSize', PP.fontSizeNormal)
    saveFigName     = char(strcat('../../../latex/figures/NNunsupRL',fcnName{f},'.eps'));
    saveas(h, saveFigName,'psc2');
else
    disp('error in plot MM in runAgents plotMMForPaper no match for plot name')
end


end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function plotMM(AC, ST, A, N, X, Y, fcnName, f, action, states)
for q=1:length(AC)
    MM(q)          = A(1,1).sim([AC(q); ST(q)]);
    
end
MM      = reshape(MM, N, N);
%summaMM = sum(MM)
%meshc(X,Y,MM);
%pcolor(X,Y,MM);shading flat

pcolor(Y,X,MM)%./repmat(max(MM,[],1),50,1));
shading flat; colorbar;
title(['Mental Model (' fcnName{f} ')' ])
hold on
op=calcOptPath(A, linspace(0,1,151));
plot(linspace(0,1,151), op, 'w*')
% if size(action)>0
%     in2=[action; states];
%     q_value = A(1,1).sim(in2);
%     plot3(states, action,q_value,'*')
%
% end
drawnow
hold off
end





function plotASRMMBest(IP,averageAMatrix,averageSMatrix, averageRMatrix, ...
    AC, ST, A,N, X,Y,fcnName,f, startState, ECO, startActions)
rows=3;cols=2;
subplot(rows,cols,1)

hold on
plot(IP.x, averageAMatrix(linspace(1,IP.numAgents, IP.numAgents),:));
axis([IP.plotSteps IP.steps 0 1.5]);
title([' Action ' ' rbfs=' num2str(IP.rbfs) 'ph=' num2str(IP.dr) ' lr=' num2str(IP.ss)  'hs=' num2str(IP.lambda) ' expl=' num2str(IP.SMtemp)]);

% STATES
subplot(rows,cols,2)
hold on
plot(IP.x, averageSMatrix(linspace(1,IP.numAgents, IP.numAgents),:));
axis([IP.plotSteps IP.steps 0 1.1]);
title([' State ' ' Steps=' num2str(IP.steps) ' Restarts=' num2str(IP.runsPerSA) ' RBFsSpreadDiv=' num2str(IP.rbfsSpreadDivisor)]);

% REWARD
subplot(rows,cols,3)
plot(IP.x, averageRMatrix(linspace(1,IP.numAgents, IP.numAgents),:));
axis([IP.plotSteps IP.steps -1 6]);
title([' Reward ']);
hold on

% MENTAL MODEL
subplot(rows,cols,4)
plotMM(AC, ST, A,N, X,Y,fcnName,f, [],[])


% BEST ACTION
subplot(rows,cols,5)

% get mental model as well as optimal action in each state
% for q=1:length(IP.testStates)
%     MMactions(q)          = A(1,1).getBestAction(testStates(q));
%     if strcmp(IP.ecoFcn, 'logistic')
%         optimalActions(q) = max(0,1 + ECO.P(1) * (1 - IP.testStates(q)/ECO.P(2)) - ECO.P(6)/IP.testStates(q));
%     elseif strcmp(IP.ecoFcn, 'static')
%         optimalActions(q) = 0.5;
%     elseif strcmp(IP.ecoFcn, 'hysteresis')
%
%         half=ECO.P(4);
%         I=ECO.P(3);%0.01;
%         K=ECO.P(5);%10;
%         g=ECO.P(1);%1;
%         corr=ECO.P(5);%10;
%         Sstar=ECO.P(6);%5;

% wrong fcn use E fcn instead
%         optimalActions(q) = max(0,((IP.testStates(q) + g*(1-IP.testStates(q)/K)*IP.testStates(q) + I - Sstar) / ...
%             (IP.testStates(q)^2/(half^2+IP.testStates(q)^2)))/corr) ;
%     end
% end
if ~IP.calcAnSolution
    
    plot(IP.testStates, MMactions, 'm.');
    hold on
end
plot(IP.testStates, optimalActions, 'k--');

axis([0 1 0 1]);
if strcmp(IP.learningType, 'supervised')
    title(['Best Action' ' Start State=' num2str(startState) ])
else
    
    if size(startActions) > 1
        title(['Best Action' ' Start S=' num2str(startState) ' Start A=' num2str(startActions(1,2)) ',' num2str(startActions(1,2))  ])
    else
        title(['Best Action' ' Start S=' num2str(startState) ])
    end
    
end
hold on
drawnow
pause (0.1)
end
